/******************************************************************/
/* ACM ICPC 2016-2017, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, October 22, 2016                                */
/******************************************************************/
/* Problem H. Hard Cuts                                           */
/*                                                                */
/* Original idea         Georgiy Korneev                          */
/* Problem statement     Gennady Korotkevich                      */
/* Test set              Gennady Korotkevich                      */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class hard_gk {
    private static Scanner in;
    private static PrintWriter out;

    private static class Solution {
        void run() {
            final int t = in.nextInt();
            for (int i = 0; i < t; i++) {
                int w = in.nextInt();
                int h = in.nextInt();
                int z = w <= h ? 0 : 1;
                final String[] answer = TABLE[Math.max(w, h) - 1][Math.min(w, h) - 1].split(",");
                out.println(answer.length);
                for (String line : answer) {
                    String[] square = line.split(" ");
                    out.println(square[z] + " " + square[1 - z] + " " + square[2]);
                }
            }
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("hard.in"));
        out = new PrintWriter("hard.out");

        new Solution().run();

        in.close();
        out.close();
    }

    private static final String[][] TABLE = {
        {
            "0 0 1"
        }, {
            "0 0 1,0 1 1",
            "0 0 2"
        }, {
            "0 0 1,0 1 1,0 2 1",
            "0 0 2,0 2 1,1 2 1",
            "0 0 3"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1",
            "0 0 2,0 2 2",
            "0 0 3,0 3 1,1 3 1,2 3 1",
            "0 0 4"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1",
            "0 0 2,0 2 2,0 4 1,1 4 1",
            "0 0 3,0 3 2,2 3 1,2 4 1",
            "0 0 4,0 4 1,1 4 1,2 4 1,3 4 1",
            "0 0 5"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1",
            "0 0 2,0 2 2,0 4 2",
            "0 0 3,0 3 3",
            "0 0 4,0 4 2,2 4 2",
            "0 0 3,0 3 3,3 0 2,3 2 2,3 4 2",
            "0 0 6"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1",
            "0 0 2,0 2 2,0 4 2,0 6 1,1 6 1",
            "0 0 3,0 3 3,0 6 1,1 6 1,2 6 1",
            "0 0 4,0 4 3,3 4 1,3 5 1,3 6 1",
            "0 0 5,0 5 2,2 5 2,4 5 1,4 6 1",
            "0 0 3,3 0 3,0 3 4,4 3 2,4 5 2",
            "0 0 7"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1",
            "0 0 2,0 2 2,0 4 2,0 6 2",
            "0 0 3,0 3 3,0 6 2,2 6 1,2 7 1",
            "0 0 4,0 4 4",
            "0 0 5,0 5 3,3 5 2,3 7 1,4 7 1",
            "0 0 6,0 6 2,2 6 2,4 6 2",
            "0 0 4,0 4 4,4 0 3,4 3 3,4 6 2,6 6 1,6 7 1",
            "0 0 8"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 1,1 8 1",
            "0 0 3,0 3 3,0 6 3",
            "0 0 4,0 4 4,0 8 1,1 8 1,2 8 1,3 8 1",
            "0 0 5,0 5 4,4 5 1,4 6 1,4 7 1,4 8 1",
            "0 0 6,0 6 3,3 6 3",
            "0 0 7,0 7 2,2 7 2,4 7 2,6 7 1,6 8 1",
            "0 0 4,4 0 4,0 4 5,5 4 3,5 7 2,7 7 1,7 8 1",
            "0 0 9"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2",
            "0 0 3,0 3 3,0 6 3,0 9 1,1 9 1,2 9 1",
            "0 0 4,0 4 4,0 8 2,2 8 2",
            "0 0 5,0 5 5",
            "0 0 6,0 6 4,4 6 2,4 8 2",
            "0 0 7,0 7 3,3 7 3,6 7 1,6 8 1,6 9 1",
            "0 0 8,0 8 2,2 8 2,4 8 2,6 8 2",
            "0 0 5,0 5 5,5 0 4,5 4 4,5 8 2,7 8 2",
            "0 0 10"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 1,1 10 1",
            "0 0 3,0 3 3,0 6 3,0 9 2,2 9 1,2 10 1",
            "0 0 4,0 4 4,0 8 3,3 8 1,3 9 1,3 10 1",
            "0 0 5,0 5 3,0 8 3,3 5 2,3 7 2,3 9 2",
            "0 0 6,0 6 3,0 9 2,3 6 3,2 9 2,4 9 2",
            "0 0 7,0 7 4,4 7 3,4 10 1,5 10 1,6 10 1",
            "0 0 8,0 8 3,3 8 3,6 8 2,6 10 1,7 10 1",
            "0 0 9,0 9 2,2 9 2,4 9 2,6 9 2,8 9 1,8 10 1",
            "0 0 5,5 0 5,0 5 6,6 5 4,6 9 2,8 9 2",
            "0 0 11"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2",
            "0 0 3,0 3 3,0 6 3,0 9 3",
            "0 0 4,0 4 4,0 8 4",
            "0 0 5,0 5 5,0 10 2,2 10 2,4 10 1,4 11 1",
            "0 0 6,0 6 6",
            "0 0 7,0 7 5,5 7 2,5 9 2,5 11 1,6 11 1",
            "0 0 8,0 8 4,4 8 4",
            "0 0 9,0 9 3,3 9 3,6 9 3",
            "0 0 6,0 6 6,6 0 4,6 4 4,6 8 4",
            "0 0 8,0 8 4,4 8 4,8 0 3,8 3 3,8 6 3,8 9 3",
            "0 0 12"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 1,1 12 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 1,1 12 1,2 12 1",
            "0 0 4,0 4 4,0 8 4,0 12 1,1 12 1,2 12 1,3 12 1",
            "0 0 5,0 5 5,0 10 3,3 10 2,3 12 1,4 12 1",
            "0 0 6,0 6 3,3 6 3,0 9 4,4 9 2,4 11 2",
            "0 0 7,0 7 3,0 10 3,3 7 4,3 11 2,5 11 2",
            "0 0 8,0 8 5,5 8 3,5 11 2,7 11 1,7 12 1",
            "0 0 9,0 9 4,4 9 4,8 9 1,8 10 1,8 11 1,8 12 1",
            "0 0 10,0 10 3,3 10 3,6 10 3,9 10 1,9 11 1,9 12 1",
            "0 0 6,6 0 5,6 5 1,0 6 7,7 5 4,7 9 4",
            "0 0 4,4 0 4,8 0 4,0 4 9,9 4 3,9 7 3,9 10 3",
            "0 0 13"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 2,2 12 1,2 13 1",
            "0 0 4,0 4 4,0 8 4,0 12 2,2 12 2",
            "0 0 5,0 5 5,0 10 4,4 10 1,4 11 1,4 12 1,4 13 1",
            "0 0 6,0 6 6,0 12 2,2 12 2,4 12 2",
            "0 0 7,0 7 7",
            "0 0 8,0 8 6,6 8 2,6 10 2,6 12 2",
            "0 0 9,0 9 5,5 9 4,5 13 1,6 13 1,7 13 1,8 13 1",
            "0 0 10,0 10 4,4 10 4,8 10 2,8 12 2",
            "0 0 11,0 11 3,3 11 3,6 11 3,9 11 2,9 13 1,10 13 1",
            "0 0 6,6 0 6,0 6 8,8 6 4,8 10 4",
            "0 0 7,0 7 7,7 0 6,7 6 6,7 12 2,9 12 2,11 12 2",
            "0 0 14"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 1,1 14 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3",
            "0 0 4,0 4 4,0 8 4,0 12 3,3 12 1,3 13 1,3 14 1",
            "0 0 5,0 5 5,0 10 5",
            "0 0 6,0 6 6,0 12 3,3 12 3",
            "0 0 7,0 7 4,0 11 4,4 7 3,4 10 3,4 13 2,6 13 1,6 14 1",
            "0 0 8,0 8 4,0 12 3,4 8 4,3 12 3,6 12 2,6 14 1,7 14 1",
            "0 0 9,0 9 6,6 9 3,6 12 3",
            "0 0 10,0 10 5,5 10 5",
            "0 0 11,0 11 4,4 11 4,8 11 3,8 14 1,9 14 1,10 14 1",
            "0 0 12,0 12 3,3 12 3,6 12 3,9 12 3",
            "0 0 10,0 10 5,5 10 5,10 0 3,10 3 3,10 6 3,10 9 3,10 12 3",
            "0 0 7,7 0 7,0 7 8,8 7 6,8 13 2,10 13 2,12 13 2",
            "0 0 15"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 1,1 15 1,2 15 1",
            "0 0 4,0 4 4,0 8 4,0 12 4",
            "0 0 5,0 5 5,0 10 3,0 13 3,3 10 2,3 12 2,3 14 2",
            "0 0 6,0 6 6,0 12 4,4 12 2,4 14 2",
            "0 0 7,0 7 7,0 14 2,2 14 2,4 14 2,6 14 1,6 15 1",
            "0 0 8,0 8 8",
            "0 0 9,0 9 7,7 9 2,7 11 2,7 13 2,7 15 1,8 15 1",
            "0 0 10,0 10 6,6 10 4,6 14 2,8 14 2",
            "0 0 11,0 11 5,5 11 3,5 14 2,8 11 3,7 14 2,9 14 2",
            "0 0 12,0 12 4,4 12 4,8 12 4",
            "0 0 13,0 13 3,3 13 3,6 13 3,9 13 3,12 13 1,12 14 1,12 15 1",
            "0 0 8,0 8 8,8 0 6,8 6 6,8 12 4,12 12 2,12 14 2",
            "0 0 10,0 10 6,10 0 5,10 5 5,6 10 6,12 10 3,12 13 3",
            "0 0 16"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 1,1 16 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 2,2 15 1,2 16 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 1,1 16 1,2 16 1,3 16 1",
            "0 0 5,0 5 5,0 10 5,0 15 2,2 15 2,4 15 1,4 16 1",
            "0 0 6,0 6 6,0 12 3,0 15 2,3 12 3,2 15 2,4 15 2",
            "0 0 7,0 7 7,0 14 3,3 14 3,6 14 1,6 15 1,6 16 1",
            "0 0 8,0 8 4,4 8 4,0 12 5,5 12 3,5 15 2,7 15 1,7 16 1",
            "0 0 9,0 9 4,0 13 4,4 9 5,4 14 3,7 14 2,7 16 1,8 16 1",
            "0 0 10,0 10 7,7 10 3,7 13 3,7 16 1,8 16 1,9 16 1",
            "0 0 11,0 11 6,6 11 3,6 14 3,9 11 2,9 13 2,9 15 2",
            "0 0 12,0 12 5,5 12 5,10 12 2,10 14 2,10 16 1,11 16 1",
            "0 0 13,0 13 4,4 13 4,8 13 4,12 13 1,12 14 1,12 15 1,12 16 1",
            "0 0 7,7 0 7,0 7 10,10 7 4,10 11 4,10 15 2,12 15 2",
            "0 0 8,8 0 7,8 7 1,0 8 9,9 7 6,9 13 4,13 13 2,13 15 2",
            "0 0 10,0 10 7,7 10 3,10 0 6,10 6 6,10 12 1,7 13 4,11 12 5",
            "0 0 17"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 2,2 16 2",
            "0 0 5,0 5 5,0 10 5,0 15 3,3 15 2,3 17 1,4 17 1",
            "0 0 6,0 6 6,0 12 6",
            "0 0 7,0 7 7,0 14 4,4 14 3,4 17 1,5 17 1,6 17 1",
            "0 0 8,0 8 8,0 16 2,2 16 2,4 16 2,6 16 2",
            "0 0 9,0 9 9",
            "0 0 10,0 10 8,8 10 2,8 12 2,8 14 2,8 16 2",
            "0 0 11,0 11 7,7 11 4,7 15 3,10 15 1,10 16 1,10 17 1",
            "0 0 12,0 12 6,6 12 6",
            "0 0 13,0 13 5,5 13 5,10 13 3,10 16 2,12 16 1,12 17 1",
            "0 0 14,0 14 4,4 14 4,8 14 4,12 14 2,12 16 2",
            "0 0 9,0 9 9,9 0 6,9 6 6,9 12 6",
            "0 0 8,8 0 8,0 8 10,10 8 6,10 14 4,14 14 2,14 16 2",
            "0 0 9,0 9 9,9 0 8,9 8 8,9 16 2,11 16 2,13 16 2,15 16 2",
            "0 0 18"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 1,1 18 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 1,1 18 1,2 18 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 3,3 16 1,3 17 1,3 18 1",
            "0 0 5,0 5 5,0 10 5,0 15 4,4 15 1,4 16 1,4 17 1,4 18 1",
            "0 0 6,0 6 6,0 12 3,3 12 3,0 15 4,4 15 2,4 17 2",
            "0 0 7,0 7 7,0 14 5,5 14 2,5 16 2,5 18 1,6 18 1",
            "0 0 8,0 8 8,0 16 3,3 16 3,6 16 2,6 18 1,7 18 1",
            "0 0 9,0 9 5,0 14 5,5 9 4,5 13 4,5 17 2,7 17 2",
            "0 0 10,0 10 5,0 15 4,5 10 5,4 15 4,8 15 2,8 17 2",
            "0 0 11,0 11 8,8 11 3,8 14 3,8 17 2,10 17 1,10 18 1",
            "0 0 12,0 12 7,7 12 5,7 17 2,9 17 2,11 17 1,11 18 1",
            "0 0 13,0 13 6,6 13 3,6 16 3,9 13 4,9 17 2,11 17 2",
            "0 0 7,0 7 6,0 13 6,7 0 7,6 7 8,6 15 4,10 15 4",
            "0 0 10,0 10 9,10 0 5,10 5 5,9 10 6,9 16 3,12 16 3",
            "0 0 9,9 0 7,9 7 1,9 8 1,0 9 10,10 7 6,10 13 6",
            "0 0 12,0 12 7,12 0 5,12 5 5,12 10 2,7 12 7,14 10 3,14 13 3,14 16 3",
            "0 0 11,0 11 8,8 11 3,11 0 7,11 7 7,8 14 5,13 14 5",
            "0 0 19"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 2,2 18 1,2 19 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4",
            "0 0 5,0 5 5,0 10 5,0 15 5",
            "0 0 6,0 6 6,0 12 6,0 18 2,2 18 2,4 18 2",
            "0 0 7,0 7 7,0 14 3,0 17 3,3 14 4,3 18 2,5 18 2",
            "0 0 8,0 8 8,0 16 4,4 16 4",
            "0 0 9,0 9 9,0 18 2,2 18 2,4 18 2,6 18 2,8 18 1,8 19 1",
            "0 0 10,0 10 10",
            "0 0 11,0 11 9,9 11 2,9 13 2,9 15 2,9 17 2,9 19 1,10 19 1",
            "0 0 12,0 12 8,8 12 4,8 16 4",
            "0 0 13,0 13 7,7 13 3,10 13 3,7 16 4,11 16 2,11 18 2",
            "0 0 14,0 14 6,6 14 6,12 14 2,12 16 2,12 18 2",
            "0 0 15,0 15 5,5 15 5,10 15 5",
            "0 0 16,0 16 4,4 16 4,8 16 4,12 16 4",
            "0 0 9,9 0 8,9 8 1,10 8 1,0 9 11,11 8 6,11 14 6",
            "0 0 10,0 10 10,10 0 8,10 8 8,10 16 4,14 16 4",
            "0 0 15,0 15 5,5 15 5,10 15 5,15 0 4,15 4 4,15 8 4,15 12 4,15 16 4",
            "0 0 20"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 1,1 20 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 1,1 20 1,2 20 1,3 20 1",
            "0 0 5,0 5 5,0 10 5,0 15 3,0 18 3,3 15 2,3 17 2,3 19 2",
            "0 0 6,0 6 6,0 12 6,0 18 3,3 18 3",
            "0 0 7,0 7 7,0 14 7",
            "0 0 8,0 8 8,0 16 5,5 16 3,5 19 2,7 19 1,7 20 1",
            "0 0 9,0 9 9,0 18 3,3 18 3,6 18 3",
            "0 0 10,0 10 5,5 10 5,0 15 6,6 15 4,6 19 2,8 19 2",
            "0 0 11,0 11 5,0 16 5,5 11 6,5 17 4,9 17 2,9 19 2",
            "0 0 12,0 12 9,9 12 3,9 15 3,9 18 3",
            "0 0 13,0 13 8,8 13 5,8 18 3,11 18 2,11 20 1,12 20 1",
            "0 0 14,0 14 7,7 14 7",
            "0 0 15,0 15 6,6 15 6,12 15 3,12 18 3",
            "0 0 16,0 16 5,5 16 5,10 16 3,10 19 2,13 16 3,12 19 2,14 19 2",
            "0 0 17,0 17 4,4 17 4,8 17 4,12 17 4,16 17 1,16 18 1,16 19 1,16 20 1",
            "0 0 9,9 0 9,0 9 12,12 9 6,12 15 6",
            "0 0 10,10 0 9,10 9 1,0 10 11,11 9 8,11 17 4,15 17 4",
            "0 0 14,0 14 7,7 14 7,14 0 6,14 6 6,14 12 6,14 18 3,17 18 3",
            "0 0 21"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 1,1 21 1,2 21 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 2,2 20 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 2,2 20 2,4 20 1,4 21 1",
            "0 0 6,0 6 6,0 12 6,0 18 4,4 18 2,4 20 2",
            "0 0 7,0 7 7,0 14 4,0 18 4,4 14 3,4 17 3,4 20 2,6 20 1,6 21 1",
            "0 0 8,0 8 8,0 16 6,6 16 2,6 18 2,6 20 2",
            "0 0 9,0 9 9,0 18 4,4 18 4,8 18 1,8 19 1,8 20 1,8 21 1",
            "0 0 10,0 10 6,0 16 6,6 10 4,6 14 4,6 18 4",
            "0 0 11,0 11 11",
            "0 0 12,0 12 6,0 18 4,6 12 6,4 18 4,8 18 4",
            "0 0 13,0 13 9,9 13 4,9 17 4,9 21 1,10 21 1,11 21 1,12 21 1",
            "0 0 14,0 14 8,8 14 6,8 20 2,10 20 2,12 20 2",
            "0 0 10,10 0 5,10 5 5,0 10 12,12 10 3,12 13 3,12 16 3,12 19 3",
            "0 0 16,0 16 6,6 16 6,12 16 4,12 20 2,14 20 2",
            "0 0 17,0 17 5,5 17 5,10 17 5,15 17 2,15 19 2,15 21 1,16 21 1",
            "0 0 18,0 18 4,4 18 4,8 18 4,12 18 4,16 18 2,16 20 2",
            "0 0 11,0 11 11,11 0 8,11 8 8,11 16 6,17 16 2,17 18 2,17 20 2",
            "0 0 10,10 0 10,0 10 12,12 10 8,12 18 4,16 18 4",
            "0 0 7,7 0 7,14 0 7,0 7 15,15 7 6,15 13 6,15 19 3,18 19 3",
            "0 0 22"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 1,1 22 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 2,2 21 1,2 22 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 3,3 20 1,3 21 1,3 22 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 3,3 20 2,3 22 1,4 22 1",
            "0 0 6,0 6 6,0 12 6,0 18 3,0 21 2,3 18 3,2 21 2,4 21 2",
            "0 0 7,0 7 7,0 14 7,0 21 2,2 21 2,4 21 2,6 21 1,6 22 1",
            "0 0 8,0 8 8,0 16 4,0 20 3,4 16 4,3 20 3,6 20 2,6 22 1,7 22 1",
            "0 0 9,0 9 9,0 18 5,5 18 4,5 22 1,6 22 1,7 22 1,8 22 1",
            "0 0 10,0 10 10,0 20 3,3 20 3,6 20 3,9 20 1,9 21 1,9 22 1",
            "0 0 11,0 11 8,0 19 4,4 19 4,8 11 3,8 14 3,8 17 3,8 20 3",
            "0 0 12,0 12 8,0 20 3,3 20 3,8 12 4,8 16 4,6 20 3,9 20 3",
            "0 0 13,0 13 10,10 13 3,10 16 3,10 19 3,10 22 1,11 22 1,12 22 1",
            "0 0 14,0 14 9,9 14 5,9 19 4,13 19 1,13 20 1,13 21 1,13 22 1",
            "0 0 9,0 9 9,0 18 5,9 0 6,9 6 6,9 12 6,5 18 5,10 18 5",
            "0 0 16,0 16 7,7 16 7,14 16 2,14 18 2,14 20 2,14 22 1,15 22 1",
            "0 0 17,0 17 6,6 17 6,12 17 3,12 20 3,15 17 2,15 19 2,15 21 2",
            "0 0 18,0 18 5,5 18 5,10 18 5,15 18 3,15 21 2,17 21 1,17 22 1",
            "0 0 19,0 19 4,4 19 4,8 19 4,12 19 4,16 19 3,16 22 1,17 22 1,18 22 1",
            "0 0 15,0 15 8,15 0 5,15 5 5,15 10 5,8 15 8,16 15 4,16 19 4",
            "0 0 14,0 14 9,14 0 7,14 7 7,9 14 9,18 14 3,18 17 3,18 20 3",
            "0 0 11,11 0 11,0 11 12,12 11 6,12 17 6,18 11 4,18 15 4,18 19 4",
            "0 0 23"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 4,4 20 1,4 21 1,4 22 1,4 23 1",
            "0 0 6,0 6 6,0 12 6,0 18 6",
            "0 0 7,0 7 7,0 14 7,0 21 3,3 21 3,6 21 1,6 22 1,6 23 1",
            "0 0 8,0 8 8,0 16 8",
            "0 0 9,0 9 9,0 18 6,6 18 3,6 21 3",
            "0 0 10,0 10 10,0 20 4,4 20 4,8 20 2,8 22 2",
            "0 0 11,0 11 6,6 11 5,6 16 1,0 17 7,7 16 4,7 20 4",
            "0 0 12,0 12 12",
            "0 0 13,0 13 6,0 19 5,5 19 1,6 13 7,5 20 4,9 20 4",
            "0 0 14,0 14 10,10 14 4,10 18 4,10 22 2,12 22 2",
            "0 0 15,0 15 9,9 15 6,9 21 3,12 21 3",
            "0 0 16,0 16 8,8 16 8",
            "0 0 17,0 17 7,7 17 7,14 17 3,14 20 3,14 23 1,15 23 1,16 23 1",
            "0 0 18,0 18 6,6 18 6,12 18 6",
            "0 0 19,0 19 5,5 19 5,10 19 5,15 19 4,15 23 1,16 23 1,17 23 1,18 23 1",
            "0 0 12,0 12 12,12 0 8,12 8 8,12 16 8",
            "0 0 12,0 12 12,12 0 9,12 9 9,12 18 6,18 18 3,18 21 3",
            "0 0 16,0 16 8,8 16 8,16 0 6,16 6 6,16 12 6,16 18 6",
            "0 0 8,0 8 8,0 16 8,8 0 15,8 15 9,17 15 6,17 21 3,20 21 3",
            "0 0 24"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 1,1 24 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 1,1 24 1,2 24 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 1,1 24 1,2 24 1,3 24 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5",
            "0 0 6,0 6 6,0 12 6,0 18 3,3 18 3,0 21 4,4 21 2,4 23 2",
            "0 0 7,0 7 7,0 14 7,0 21 4,4 21 3,4 24 1,5 24 1,6 24 1",
            "0 0 8,0 8 8,0 16 4,4 16 4,0 20 5,5 20 3,5 23 2,7 23 1,7 24 1",
            "0 0 9,0 9 9,0 18 7,7 18 2,7 20 2,7 22 2,7 24 1,8 24 1",
            "0 0 10,0 10 10,0 20 5,5 20 5",
            "0 0 11,0 11 11,0 22 3,3 22 3,6 22 3,9 22 2,9 24 1,10 24 1",
            "0 0 12,0 12 4,4 12 4,8 12 4,0 16 9,9 16 3,9 19 3,9 22 3",
            "0 0 13,0 13 4,0 17 4,0 21 4,4 13 9,4 22 3,7 22 3,10 22 3",
            "0 0 14,0 14 11,11 14 3,11 17 3,11 20 3,11 23 2,13 23 1,13 24 1",
            "0 0 15,0 15 10,10 15 5,10 20 5",
            "0 0 16,0 16 9,9 16 7,9 23 2,11 23 2,13 23 2,15 23 1,15 24 1",
            "0 0 17,0 17 8,8 17 4,8 21 4,12 17 5,12 22 3,15 22 2,15 24 1,16 24 1",
            "0 0 18,0 18 7,7 18 7,14 18 4,14 22 3,17 22 1,17 23 1,17 24 1",
            "0 0 19,0 19 6,6 19 6,12 19 3,12 22 3,15 19 4,15 23 2,17 23 2",
            "0 0 20,0 20 5,5 20 5,10 20 5,15 20 5",
            "0 0 7,7 0 7,0 7 9,0 16 9,14 0 7,9 7 12,9 19 6,15 19 6",
            "0 0 11,11 0 11,0 11 14,14 11 8,14 19 6,20 19 2,20 21 2,20 23 2",
            "0 0 8,8 0 8,16 0 7,16 7 1,0 8 17,17 7 6,17 13 6,17 19 6",
            "0 0 16,0 16 9,16 0 8,16 8 8,9 16 9,18 16 6,18 22 3,21 22 3",
            "0 0 25"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 2,2 24 1,2 25 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 2,2 24 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 3,0 23 3,3 20 2,3 22 2,3 24 2",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 2,2 24 2,4 24 2",
            "0 0 7,0 7 7,0 14 7,0 21 5,5 21 2,5 23 2,5 25 1,6 25 1",
            "0 0 8,0 8 8,0 16 8,0 24 2,2 24 2,4 24 2,6 24 2",
            "0 0 9,0 9 9,0 18 4,0 22 4,4 18 5,4 23 3,7 23 2,7 25 1,8 25 1",
            "0 0 10,0 10 10,0 20 6,6 20 4,6 24 2,8 24 2",
            "0 0 11,0 11 11,0 22 4,4 22 4,8 22 3,8 25 1,9 25 1,10 25 1",
            "0 0 12,0 12 6,6 12 6,0 18 8,8 18 4,8 22 4",
            "0 0 13,0 13 13",
            "0 0 14,0 14 6,0 20 6,6 14 8,6 22 4,10 22 4",
            "0 0 15,0 15 11,11 15 4,11 19 4,11 23 3,14 23 1,14 24 1,14 25 1",
            "0 0 16,0 16 10,10 16 6,10 22 4,14 22 2,14 24 2",
            "0 0 17,0 17 9,9 17 4,13 17 4,9 21 5,14 21 3,14 24 2,16 24 1,16 25 1",
            "0 0 18,0 18 8,8 18 8,16 18 2,16 20 2,16 22 2,16 24 2",
            "0 0 19,0 19 7,7 19 7,14 19 5,14 24 2,16 24 2,18 24 1,18 25 1",
            "0 0 20,0 20 6,6 20 6,12 20 6,18 20 2,18 22 2,18 24 2",
            "0 0 14,0 14 12,14 0 7,14 7 7,12 14 9,12 23 3,15 23 3,18 23 3",
            "0 0 12,12 0 10,12 10 2,0 12 14,14 10 8,14 18 8",
            "0 0 13,0 13 13,13 0 10,13 10 10,13 20 6,19 20 4,19 24 2,21 24 2",
            "0 0 8,8 0 8,16 0 8,0 8 18,18 8 6,18 14 6,18 20 6",
            "0 0 13,0 13 13,13 0 12,13 12 6,19 12 6,13 18 8,21 18 4,21 22 4",
            "0 0 26"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 1,1 26 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 3,3 24 1,3 25 1,3 26 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 2,2 25 2,4 25 1,4 26 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 3,3 24 3",
            "0 0 7,0 7 7,0 14 7,0 21 3,0 24 3,3 21 4,3 25 2,5 25 2",
            "0 0 8,0 8 8,0 16 8,0 24 3,3 24 3,6 24 2,6 26 1,7 26 1",
            "0 0 9,0 9 9,0 18 9",
            "0 0 10,0 10 10,0 20 7,7 20 3,7 23 3,7 26 1,8 26 1,9 26 1",
            "0 0 11,0 11 11,0 22 5,5 22 3,5 25 2,8 22 3,7 25 2,9 25 2",
            "0 0 12,0 12 12,0 24 3,3 24 3,6 24 3,9 24 3",
            "0 0 13,0 13 7,0 20 7,7 13 6,7 19 6,7 25 2,9 25 2,11 25 2",
            "0 0 14,0 14 7,0 21 6,7 14 7,6 21 6,12 21 2,12 23 2,12 25 2",
            "0 0 15,0 15 12,12 15 3,12 18 3,12 21 3,12 24 3",
            "0 0 16,0 16 11,11 16 5,11 21 3,11 24 3,14 21 2,14 23 2,14 25 2",
            "0 0 17,0 17 10,10 17 7,10 24 3,13 24 3,16 24 1,16 25 1,16 26 1",
            "0 0 18,0 18 9,9 18 9",
            "0 0 19,0 19 8,8 19 8,16 19 3,16 22 3,16 25 2,18 25 1,18 26 1",
            "0 0 20,0 20 7,7 20 7,14 20 3,17 20 3,14 23 4,18 23 2,18 25 2",
            "0 0 21,0 21 6,6 21 6,12 21 6,18 21 3,18 24 3",
            "0 0 11,11 0 11,0 11 16,16 11 6,16 17 6,16 23 4,20 23 2,20 25 2",
            "0 0 16,0 16 11,11 16 5,16 0 7,16 7 7,16 14 7,11 21 6,17 21 6",
            "0 0 12,12 0 12,0 12 15,15 12 9,15 21 6,21 21 3,21 24 3",
            "0 0 14,0 14 13,14 0 11,14 11 3,17 11 3,13 14 7,13 21 6,20 11 5,20 16 5,19 21 6",
            "0 0 13,13 0 13,0 13 14,14 13 6,20 13 6,14 19 8,22 19 4,22 23 4",
            "0 0 27"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 1,1 27 1,2 27 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 3,3 25 2,3 27 1,4 27 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 4,4 24 2,4 26 2",
            "0 0 7,0 7 7,0 14 7,0 21 7",
            "0 0 8,0 8 8,0 16 8,0 24 4,4 24 4",
            "0 0 9,0 9 9,0 18 5,0 23 5,5 18 4,5 22 4,5 26 2,7 26 2",
            "0 0 10,0 10 10,0 20 8,8 20 2,8 22 2,8 24 2,8 26 2",
            "0 0 11,0 11 11,0 22 6,6 22 3,6 25 3,9 22 2,9 24 2,9 26 2",
            "0 0 12,0 12 12,0 24 4,4 24 4,8 24 4",
            "0 0 13,0 13 10,0 23 5,5 23 5,10 13 3,10 16 3,10 19 3,10 22 3,10 25 3",
            "0 0 14,0 14 14",
            "0 0 9,0 9 9,9 0 6,9 6 6,9 12 6,0 18 10,10 18 5,10 23 5",
            "0 0 16,0 16 12,12 16 4,12 20 4,12 24 4",
            "0 0 17,0 17 11,11 17 6,11 23 3,11 26 2,14 23 3,13 26 2,15 26 2",
            "0 0 18,0 18 10,10 18 8,10 26 2,12 26 2,14 26 2,16 26 2",
            "0 0 19,0 19 9,9 19 5,9 24 4,14 19 5,13 24 4,17 24 2,17 26 2",
            "0 0 20,0 20 8,8 20 8,16 20 4,16 24 4",
            "0 0 21,0 21 7,7 21 7,14 21 7",
            "0 0 22,0 22 6,6 22 6,12 22 6,18 22 4,18 26 2,20 26 2",
            "0 0 23,0 23 5,5 23 5,10 23 5,15 23 5,20 23 3,20 26 2,22 26 1,22 27 1",
            "0 0 12,12 0 12,0 12 16,16 12 8,16 20 8",
            "0 0 14,0 14 14,14 0 11,14 11 11,14 22 6,20 22 3,20 25 3,23 22 2,23 24 2,23 26 2",
            "0 0 14,0 14 14,14 0 12,14 12 12,14 24 4,18 24 4,22 24 4",
            "0 0 17,0 17 11,11 17 3,14 17 3,17 0 10,17 10 10,11 20 8,19 20 8",
            "0 0 28"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 1,1 28 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 2,2 27 1,2 28 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 1,1 28 1,2 28 1,3 28 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 4,4 25 1,4 26 1,4 27 1,4 28 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 3,0 27 2,3 24 3,2 27 2,4 27 2",
            "0 0 7,0 7 7,0 14 7,0 21 4,0 25 4,4 21 3,4 24 3,4 27 2,6 27 1,6 28 1",
            "0 0 8,0 8 8,0 16 8,0 24 5,5 24 3,5 27 2,7 27 1,7 28 1",
            "0 0 9,0 9 9,0 18 9,0 27 2,2 27 2,4 27 2,6 27 2,8 27 1,8 28 1",
            "0 0 10,0 10 10,0 20 5,0 25 4,5 20 5,4 25 4,8 25 2,8 27 2",
            "0 0 11,0 11 11,0 22 7,7 22 4,7 26 3,10 26 1,10 27 1,10 28 1",
            "0 0 12,0 12 12,0 24 5,5 24 5,10 24 2,10 26 2,10 28 1,11 28 1",
            "0 0 13,0 13 13,0 26 3,3 26 3,6 26 3,9 26 3,12 26 1,12 27 1,12 28 1",
            "0 0 14,0 14 7,7 14 7,0 21 8,8 21 6,8 27 2,10 27 2,12 27 2",
            "0 0 15,0 15 7,0 22 7,7 15 8,7 23 6,13 23 2,13 25 2,13 27 2",
            "0 0 16,0 16 13,13 16 3,13 19 3,13 22 3,13 25 3,13 28 1,14 28 1,15 28 1",
            "0 0 17,0 17 12,12 17 5,12 22 5,12 27 2,14 27 2,16 27 1,16 28 1",
            "0 0 18,0 18 11,11 18 7,11 25 4,15 25 3,15 28 1,16 28 1,17 28 1",
            "0 0 19,0 19 10,10 19 5,10 24 5,15 19 4,15 23 4,15 27 2,17 27 2",
            "0 0 20,0 20 9,9 20 9,18 20 2,18 22 2,18 24 2,18 26 2,18 28 1,19 28 1",
            "0 0 21,0 21 8,8 21 8,16 21 5,16 26 3,19 26 2,19 28 1,20 28 1",
            "0 0 11,11 0 11,0 11 18,18 11 4,18 15 4,18 19 4,18 23 4,18 27 2,20 27 2",
            "0 0 23,0 23 6,6 23 6,12 23 6,18 23 3,18 26 3,21 23 2,21 25 2,21 27 2",
            "0 0 12,12 0 12,0 12 17,17 12 7,17 19 7,17 26 3,20 26 3,23 26 1,23 27 1,23 28 1",
            "0 0 14,14 0 11,14 11 3,0 14 15,15 14 2,15 16 2,15 18 1,16 18 1,17 11 8,15 19 10",
            "0 0 13,13 0 13,0 13 16,16 13 10,16 23 6,22 23 4,22 27 2,24 27 2",
            "0 0 14,14 0 13,14 13 1,0 14 15,15 13 12,15 25 4,19 25 4,23 25 4",
            "0 0 21,0 21 8,8 21 8,21 0 7,21 7 7,21 14 7,16 21 8,24 21 4,24 25 4",
            "0 0 29"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 2,2 28 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 2,2 28 2,4 28 2,6 28 1,6 29 1",
            "0 0 8,0 8 8,0 16 8,0 24 6,6 24 2,6 26 2,6 28 2",
            "0 0 9,0 9 9,0 18 9,0 27 3,3 27 3,6 27 3",
            "0 0 10,0 10 10,0 20 10",
            "0 0 11,0 11 11,0 22 8,8 22 3,8 25 3,8 28 2,10 28 1,10 29 1",
            "0 0 12,0 12 12,0 24 6,6 24 6",
            "0 0 13,0 13 13,0 26 4,4 26 4,8 26 4,12 26 1,12 27 1,12 28 1,12 29 1",
            "0 0 14,0 14 8,0 22 8,8 14 6,8 20 6,8 26 4,12 26 2,12 28 2",
            "0 0 15,0 15 15",
            "0 0 16,0 16 8,0 24 6,8 16 8,6 24 6,12 24 4,12 28 2,14 28 2",
            "0 0 17,0 17 13,13 17 4,13 21 4,13 25 4,13 29 1,14 29 1,15 29 1,16 29 1",
            "0 0 18,0 18 12,12 18 6,12 24 6",
            "0 0 19,0 19 11,11 19 8,11 27 3,14 27 3,17 27 2,17 29 1,18 29 1",
            "0 0 20,0 20 10,10 20 10",
            "0 0 21,0 21 9,9 21 9,18 21 3,18 24 3,18 27 3",
            "0 0 22,0 22 8,8 22 8,16 22 6,16 28 2,18 28 2,20 28 2",
            "0 0 23,0 23 7,7 23 7,14 23 7,21 23 2,21 25 2,21 27 2,21 29 1,22 29 1",
            "0 0 24,0 24 6,6 24 6,12 24 6,18 24 6",
            "0 0 15,0 15 15,15 0 10,15 10 10,15 20 10",
            "0 0 20,0 20 10,10 20 10,20 0 6,20 6 6,20 12 6,20 18 6,20 24 6",
            "0 0 15,0 15 15,15 0 12,15 12 12,15 24 6,21 24 6",
            "0 0 14,14 0 14,0 14 16,16 14 12,16 26 4,20 26 4,24 26 4",
            "0 0 20,0 20 10,10 20 10,20 0 9,20 9 9,20 18 9,20 27 3,23 27 3,26 27 3",
            "0 0 30"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 1,1 30 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 1,1 30 1,2 30 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 3,3 28 1,3 29 1,3 30 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 3,0 28 3,3 25 2,3 27 2,3 29 2",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 3,3 24 3,0 27 4,4 27 2,4 29 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 3,3 28 3,6 28 1,6 29 1,6 30 1",
            "0 0 8,0 8 8,0 16 8,0 24 4,0 28 3,4 24 4,3 28 3,6 28 2,6 30 1,7 30 1",
            "0 0 9,0 9 9,0 18 9,0 27 4,4 27 4,8 27 1,8 28 1,8 29 1,8 30 1",
            "0 0 10,0 10 10,0 20 5,5 20 5,0 25 6,6 25 4,6 29 2,8 29 2",
            "0 0 11,0 11 11,0 22 9,9 22 2,9 24 2,9 26 2,9 28 2,9 30 1,10 30 1",
            "0 0 12,0 12 12,0 24 7,7 24 5,7 29 2,9 29 2,11 29 1,11 30 1",
            "0 0 13,0 13 13,0 26 5,5 26 5,10 26 3,10 29 2,12 29 1,12 30 1",
            "0 0 14,0 14 7,7 14 7,0 21 10,10 21 4,10 25 4,10 29 2,12 29 2",
            "0 0 15,0 15 10,0 25 6,10 15 5,10 20 5,6 25 6,12 25 3,12 28 3",
            "0 0 16,0 16 10,0 26 5,5 26 5,10 16 6,10 22 6,10 28 3,13 28 3",
            "0 0 17,0 17 7,0 24 7,7 17 10,7 27 4,11 27 4,15 27 2,15 29 2",
            "0 0 18,0 18 13,13 18 5,13 23 5,13 28 3,16 28 2,16 30 1,17 30 1",
            "0 0 19,0 19 12,12 19 7,12 26 5,17 26 2,17 28 2,17 30 1,18 30 1",
            "0 0 20,0 20 11,11 20 9,11 29 2,13 29 2,15 29 2,17 29 2,19 29 1,19 30 1",
            "0 0 21,0 21 10,10 21 5,10 26 5,15 21 6,15 27 4,19 27 2,19 29 2",
            "0 0 11,0 11 10,0 21 10,11 0 11,10 11 12,10 23 8,18 23 4,18 27 4",
            "0 0 11,0 11 11,0 22 9,9 22 2,11 0 12,11 12 12,9 24 7,16 24 7",
            "0 0 16,0 16 15,16 0 8,16 8 8,15 16 9,15 25 6,21 25 3,21 28 3",
            "0 0 14,14 0 11,14 11 3,0 14 17,17 11 8,17 19 8,17 27 4,21 27 4",
            "0 0 11,0 11 11,0 22 9,11 0 15,11 15 7,9 22 9,18 15 8,18 23 8",
            "0 0 15,15 0 12,15 12 2,15 14 1,0 15 16,17 12 2,16 14 3,16 17 3,19 12 8,16 20 11",
            "0 0 15,15 0 13,15 13 1,15 14 1,0 15 16,16 13 12,16 25 6,22 25 6",
            "0 0 10,0 10 10,10 0 19,10 19 1,0 20 11,11 19 12,23 19 6,23 25 6",
            "0 0 13,0 13 9,0 22 9,9 13 4,13 0 17,9 17 14,23 17 7,23 24 7",
            "0 0 31"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 2,2 30 1,2 31 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 2,2 30 2,4 30 1,4 31 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 2,2 30 2,4 30 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 4,4 28 3,4 31 1,5 31 1,6 31 1",
            "0 0 8,0 8 8,0 16 8,0 24 8",
            "0 0 9,0 9 9,0 18 9,0 27 5,5 27 4,5 31 1,6 31 1,7 31 1,8 31 1",
            "0 0 10,0 10 10,0 20 6,0 26 6,6 20 4,6 24 4,6 28 4",
            "0 0 11,0 11 11,0 22 5,0 27 5,5 22 6,5 28 4,9 28 2,9 30 2",
            "0 0 12,0 12 12,0 24 8,8 24 4,8 28 4",
            "0 0 13,0 13 13,0 26 6,6 26 3,6 29 3,9 26 4,9 30 2,11 30 2",
            "0 0 14,0 14 14,0 28 4,4 28 4,8 28 4,12 28 2,12 30 2",
            "0 0 15,0 15 8,8 15 7,8 22 1,0 23 9,9 22 6,9 28 4,13 28 2,13 30 2",
            "0 0 16,0 16 16",
            "0 0 17,0 17 8,0 25 7,7 25 1,8 17 9,7 26 6,13 26 4,13 30 2,15 30 2",
            "0 0 18,0 18 14,14 18 4,14 22 4,14 26 4,14 30 2,16 30 2",
            "0 0 19,0 19 13,13 19 6,13 25 3,16 25 3,13 28 4,17 28 2,17 30 2",
            "0 0 20,0 20 12,12 20 8,12 28 4,16 28 4",
            "0 0 21,0 21 11,11 21 5,16 21 5,11 26 6,17 26 4,17 30 2,19 30 2",
            "0 0 22,0 22 10,10 22 6,10 28 4,16 22 6,14 28 4,18 28 4",
            "0 0 23,0 23 9,9 23 9,18 23 5,18 28 4,22 28 1,22 29 1,22 30 1,22 31 1",
            "0 0 24,0 24 8,8 24 8,16 24 8",
            "0 0 25,0 25 7,7 25 7,14 25 7,21 25 4,21 29 3,24 29 1,24 30 1,24 31 1",
            "0 0 26,0 26 6,6 26 6,12 26 6,18 26 6,24 26 2,24 28 2,24 30 2",
            "0 0 15,15 0 12,15 12 2,15 14 1,16 14 1,0 15 17,17 12 10,17 22 10",
            "0 0 16,0 16 16,16 0 12,16 12 12,16 24 8,24 24 4,24 28 4",
            "0 0 18,0 18 14,14 18 4,18 0 11,18 11 11,14 22 10,24 22 5,24 27 5",
            "0 0 20,0 20 12,20 0 10,20 10 10,12 20 12,24 20 6,24 26 6",
            "0 0 19,0 19 13,19 0 12,19 12 7,13 19 13,26 12 5,26 17 5,26 22 5,26 27 5",
            "0 0 32"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 1,1 32 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 1,1 32 1,2 32 1,3 32 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 3,3 30 2,3 32 1,4 32 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 3,3 30 3",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 5,5 28 2,5 30 2,5 32 1,6 32 1",
            "0 0 8,0 8 8,0 16 8,0 24 4,4 24 4,0 28 5,5 28 3,5 31 2,7 31 1,7 32 1",
            "0 0 9,0 9 9,0 18 9,0 27 6,6 27 3,6 30 3",
            "0 0 10,0 10 10,0 20 10,0 30 3,3 30 3,6 30 3,9 30 1,9 31 1,9 32 1",
            "0 0 11,0 11 11,0 22 11",
            "0 0 12,0 12 12,0 24 9,9 24 3,9 27 3,9 30 3",
            "0 0 13,0 13 13,0 26 7,7 26 3,10 26 3,7 29 4,11 29 2,11 31 2",
            "0 0 14,0 14 7,0 21 6,0 27 6,7 14 7,6 21 8,6 29 4,10 29 4",
            "0 0 15,0 15 9,0 24 9,9 15 6,9 21 6,9 27 6",
            "0 0 16,0 16 10,0 26 7,7 26 3,10 16 6,10 22 6,10 28 1,7 29 4,11 28 5",
            "0 0 17,0 17 10,0 27 6,10 17 7,10 24 3,6 27 6,12 27 1,13 24 4,12 28 5",
            "0 0 18,0 18 9,0 27 6,9 18 9,6 27 6,12 27 6",
            "0 0 19,0 19 7,0 26 7,7 19 6,13 19 6,7 25 8,15 25 4,15 29 4",
            "0 0 20,0 20 13,13 20 7,13 27 3,13 30 3,16 27 4,16 31 2,18 31 2",
            "0 0 21,0 21 12,12 21 9,12 30 3,15 30 3,18 30 3",
            "0 0 22,0 22 11,11 22 11",
            "0 0 23,0 23 10,10 23 10,20 23 3,20 26 3,20 29 3,20 32 1,21 32 1,22 32 1",
            "0 0 24,0 24 9,9 24 9,18 24 6,18 30 3,21 30 3",
            "0 0 25,0 25 8,8 25 8,16 25 4,16 29 4,20 25 5,20 30 3,23 30 2,23 32 1,24 32 1",
            "0 0 17,0 17 16,16 17 1,17 0 9,17 9 9,16 18 10,16 28 5,21 28 5",
            "0 0 27,0 27 6,6 27 6,12 27 6,18 27 6,24 27 3,24 30 3",
            "0 0 15,15 0 13,15 13 2,17 13 1,17 14 1,0 15 18,18 13 10,18 23 10",
            "0 0 11,0 11 11,0 22 11,11 0 18,11 18 9,11 27 6,20 18 9,17 27 6,23 27 6",
            "0 0 15,15 0 15,0 15 18,18 15 12,18 27 6,24 27 6",
            "0 0 22,0 22 11,11 22 11,22 0 9,22 9 9,22 18 9,22 27 6,28 27 3,28 30 3",
            "0 0 11,0 11 11,0 22 11,11 0 21,11 21 12,23 21 9,23 30 3,26 30 3,29 30 3",
            "0 0 33"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 1,1 33 1,2 33 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 2,2 32 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 4,4 30 1,4 31 1,4 32 1,4 33 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 4,4 30 2,4 32 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 3,0 31 3,3 28 4,3 32 2,5 32 2",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 2,2 32 2,4 32 2,6 32 2",
            "0 0 9,0 9 9,0 18 9,0 27 7,7 27 2,7 29 2,7 31 2,7 33 1,8 33 1",
            "0 0 10,0 10 10,0 20 10,0 30 4,4 30 4,8 30 2,8 32 2",
            "0 0 11,0 11 11,0 22 8,0 30 4,4 30 4,8 22 3,8 25 3,8 28 3,8 31 3",
            "0 0 12,0 12 12,0 24 6,0 30 4,6 24 6,4 30 4,8 30 4",
            "0 0 13,0 13 13,0 26 8,8 26 5,8 31 3,11 31 2,11 33 1,12 33 1",
            "0 0 14,0 14 14,0 28 6,6 28 6,12 28 2,12 30 2,12 32 2",
            "0 0 15,0 15 10,0 25 9,10 15 5,10 20 5,9 25 6,9 31 3,12 31 3",
            "0 0 16,0 16 8,8 16 8,0 24 10,10 24 6,10 30 4,14 30 2,14 32 2",
            "0 0 17,0 17 17",
            "0 0 18,0 18 8,0 26 8,8 18 10,8 28 6,14 28 4,14 32 2,16 32 2",
            "0 0 19,0 19 10,0 29 5,5 29 5,10 19 9,10 28 6,16 28 3,16 31 3",
            "0 0 20,0 20 14,14 20 6,14 26 6,14 32 2,16 32 2,18 32 2",
            "0 0 21,0 21 13,13 21 8,13 29 5,18 29 3,18 32 2,20 32 1,20 33 1",
            "0 0 22,0 22 12,12 22 6,12 28 6,18 22 4,18 26 4,18 30 4",
            "0 0 23,0 23 11,11 23 8,11 31 3,14 31 3,19 23 4,19 27 4,17 31 3,20 31 3",
            "0 0 24,0 24 10,10 24 10,20 24 4,20 28 4,20 32 2,22 32 2",
            "0 0 12,0 12 11,0 23 11,11 12 1,12 0 13,11 13 14,11 27 7,18 27 7",
            "0 0 26,0 26 8,8 26 8,16 26 8,24 26 2,24 28 2,24 30 2,24 32 2",
            "0 0 27,0 27 7,7 27 7,14 27 7,21 27 3,24 27 3,21 30 4,25 30 2,25 32 2",
            "0 0 14,14 0 14,0 14 20,20 14 8,20 22 8,20 30 4,24 30 4",
            "0 0 17,0 17 17,17 0 12,17 12 12,17 24 6,17 30 4,23 24 6,21 30 4,25 30 4",
            "0 0 16,16 0 14,16 14 2,0 16 18,18 14 12,18 26 8,26 26 4,26 30 4",
            "0 0 17,0 17 17,17 0 14,17 14 14,17 28 6,23 28 6,29 28 2,29 30 2,29 32 2",
            "0 0 20,0 20 14,14 20 6,20 0 12,20 12 12,20 24 2,14 26 8,22 24 10",
            "0 0 22,0 22 12,22 0 11,22 11 11,12 22 12,24 22 9,24 31 3,27 31 3,30 31 3",
            "0 0 34"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 1,1 34 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 2,2 33 1,2 34 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 3,3 32 1,3 33 1,3 34 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 3,0 33 2,3 30 3,2 33 2,4 33 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 3,3 32 3,6 32 2,6 34 1,7 34 1",
            "0 0 9,0 9 9,0 18 9,0 27 4,0 31 4,4 27 5,4 32 3,7 32 2,7 34 1,8 34 1",
            "0 0 10,0 10 10,0 20 10,0 30 5,5 30 5",
            "0 0 11,0 11 11,0 22 6,6 22 5,6 27 1,0 28 7,7 27 4,7 31 4",
            "0 0 12,0 12 12,0 24 8,0 32 3,3 32 3,8 24 4,8 28 4,6 32 3,9 32 3",
            "0 0 13,0 13 13,0 26 9,9 26 4,9 30 4,9 34 1,10 34 1,11 34 1,12 34 1",
            "0 0 14,0 14 14,0 28 7,7 28 7",
            "0 0 15,0 15 15,0 30 5,5 30 5,10 30 5",
            "0 0 16,0 16 9,9 16 7,9 23 1,9 24 1,0 25 10,10 23 6,10 29 6",
            "0 0 17,0 17 9,0 26 9,9 17 8,9 25 8,9 33 2,11 33 2,13 33 2,15 33 2",
            "0 0 18,0 18 9,0 27 8,9 18 9,8 27 8,16 27 2,16 29 2,16 31 2,16 33 2",
            "0 0 19,0 19 9,0 28 7,7 28 1,8 28 1,9 19 10,7 29 6,13 29 6",
            "0 0 20,0 20 15,15 20 5,15 25 5,15 30 5",
            "0 0 21,0 21 14,14 21 7,14 28 7",
            "0 0 22,0 22 13,13 22 9,13 31 4,17 31 4,21 31 1,21 32 1,21 33 1,21 34 1",
            "0 0 23,0 23 12,12 23 8,12 31 4,16 31 4,20 23 3,20 26 3,20 29 3,20 32 3",
            "0 0 24,0 24 11,11 24 6,11 30 5,16 30 1,17 24 7,16 31 4,20 31 4",
            "0 0 25,0 25 10,10 25 10,20 25 5,20 30 5",
            "0 0 13,0 13 12,0 25 10,10 25 2,13 0 13,12 13 14,10 27 8,18 27 8",
            "0 0 27,0 27 8,8 27 8,16 27 8,24 27 3,24 30 3,24 33 2,26 33 1,26 34 1",
            "0 0 28,0 28 7,7 28 7,14 28 7,21 28 7",
            "0 0 14,0 14 14,0 28 7,7 28 7,14 0 15,14 15 15,14 30 5,19 30 5,24 30 5",
            "0 0 15,15 0 15,0 15 20,20 15 10,20 25 10",
            "0 0 17,17 0 14,17 14 3,0 17 18,20 14 3,18 17 5,23 14 8,18 22 13",
            "0 0 16,16 0 16,0 16 19,19 16 13,19 29 6,25 29 3,25 32 3,28 29 4,28 33 2,30 33 2",
            "0 0 11,11 0 11,22 0 11,0 11 24,24 11 9,24 20 9,24 29 6,30 29 3,30 32 3",
            "0 0 19,0 19 16,19 0 15,19 15 4,16 19 7,23 15 11,16 26 9,25 26 9",
            "0 0 35"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 3,0 33 3,3 30 2,3 32 2,3 34 2",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 4,0 32 4,4 28 3,4 31 3,4 34 2,6 34 1,6 35 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 4,4 32 4",
            "0 0 9,0 9 9,0 18 9,0 27 9",
            "0 0 10,0 10 10,0 20 10,0 30 6,6 30 4,6 34 2,8 34 2",
            "0 0 11,0 11 11,0 22 11,0 33 3,3 33 3,6 33 3,9 33 2,9 35 1,10 35 1",
            "0 0 12,0 12 12,0 24 12",
            "0 0 13,0 13 13,0 26 10,10 26 3,10 29 3,10 32 3,10 35 1,11 35 1,12 35 1",
            "0 0 14,0 14 14,0 28 8,8 28 6,8 34 2,10 34 2,12 34 2",
            "0 0 15,0 15 15,0 30 6,6 30 6,12 30 3,12 33 3",
            "0 0 16,0 16 16,0 32 4,4 32 4,8 32 4,12 32 4",
            "0 0 17,0 17 12,0 29 7,12 17 5,12 22 5,12 27 2,7 29 7,14 27 3,14 30 3,14 33 3",
            "0 0 18,0 18 18",
            "0 0 19,0 19 12,0 31 5,5 31 5,10 31 2,12 19 7,12 26 7,10 33 3,13 33 3,16 33 3",
            "0 0 20,0 20 16,16 20 4,16 24 4,16 28 4,16 32 4",
            "0 0 21,0 21 15,15 21 6,15 27 6,15 33 3,18 33 3",
            "0 0 22,0 22 14,14 22 8,14 30 6,20 30 2,20 32 2,20 34 2",
            "0 0 23,0 23 13,13 23 10,13 33 3,16 33 3,19 33 3,22 33 1,22 34 1,22 35 1",
            "0 0 24,0 24 12,12 24 12",
            "0 0 25,0 25 11,11 25 11,22 25 3,22 28 3,22 31 3,22 34 2,24 34 1,24 35 1",
            "0 0 26,0 26 10,10 26 10,20 26 6,20 32 4,24 32 2,24 34 2",
            "0 0 27,0 27 9,9 27 9,18 27 9",
            "0 0 28,0 28 8,8 28 8,16 28 8,24 28 4,24 32 4",
            "0 0 9,0 9 9,0 18 9,0 27 9,9 0 20,9 20 16,25 20 4,25 24 4,25 28 4,25 32 4",
            "0 0 18,0 18 18,18 0 12,18 12 12,18 24 12",
            "0 0 17,17 0 14,17 14 3,0 17 19,20 14 3,23 14 3,19 17 7,26 14 5,26 19 5,19 24 12",
            "0 0 16,16 0 16,0 16 20,20 16 12,20 28 8,28 28 4,28 32 4",
            "0 0 24,0 24 12,12 24 12,24 0 9,24 9 9,24 18 9,24 27 9",
            "0 0 18,0 18 18,18 0 16,18 16 16,18 32 4,22 32 4,26 32 4,30 32 4",
            "0 0 21,0 21 15,21 0 14,21 14 7,28 14 7,15 21 15,30 21 5,30 26 5,30 31 5",
            "0 0 36"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 1,1 36 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 1,1 36 1,2 36 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 1,1 36 1,2 36 1,3 36 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 2,2 35 2,4 35 1,4 36 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 3,3 30 3,0 33 4,4 33 2,4 35 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 2,2 35 2,4 35 2,6 35 1,6 36 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 5,5 32 3,5 35 2,7 35 1,7 36 1",
            "0 0 9,0 9 9,0 18 9,0 27 5,0 32 5,5 27 4,5 31 4,5 35 2,7 35 2",
            "0 0 10,0 10 10,0 20 10,0 30 7,7 30 3,7 33 3,7 36 1,8 36 1,9 36 1",
            "0 0 11,0 11 11,0 22 11,0 33 4,4 33 4,8 33 3,8 36 1,9 36 1,10 36 1",
            "0 0 12,0 12 12,0 24 4,4 24 4,8 24 4,0 28 9,9 28 3,9 31 3,9 34 3",
            "0 0 13,0 13 13,0 26 6,0 32 5,5 32 1,6 26 7,5 33 4,9 33 4",
            "0 0 14,0 14 14,0 28 9,9 28 5,9 33 4,13 33 1,13 34 1,13 35 1,13 36 1",
            "0 0 15,0 15 10,10 15 5,10 20 5,0 25 12,12 25 3,12 28 3,12 31 3,12 34 3",
            "0 0 16,0 16 16,0 32 5,5 32 5,10 32 3,10 35 2,13 32 3,12 35 2,14 35 2",
            "0 0 17,0 17 9,9 17 8,9 25 1,10 25 1,0 26 11,11 25 6,11 31 6",
            "0 0 18,0 18 11,0 29 8,8 29 3,11 18 7,11 25 7,8 32 5,13 32 5",
            "0 0 19,0 19 11,0 30 7,11 19 8,11 27 3,7 30 7,14 27 5,14 32 5",
            "0 0 20,0 20 9,0 29 8,8 29 1,8 30 1,9 20 11,8 31 6,14 31 6",
            "0 0 21,0 21 16,16 21 5,16 26 5,16 31 3,16 34 3,19 31 2,19 33 2,19 35 2",
            "0 0 11,11 0 11,0 11 12,12 11 10,12 21 2,0 23 14,14 21 8,14 29 8",
            "0 0 23,0 23 14,14 23 9,14 32 5,19 32 4,19 36 1,20 36 1,21 36 1,22 36 1",
            "0 0 24,0 24 13,13 24 6,19 24 5,19 29 1,13 30 7,20 29 4,20 33 4",
            "0 0 25,0 25 12,12 25 4,12 29 4,12 33 4,16 25 9,16 34 3,19 34 3,22 34 3",
            "0 0 26,0 26 11,11 26 11,22 26 4,22 30 4,22 34 3,25 34 1,25 35 1,25 36 1",
            "0 0 27,0 27 10,10 27 10,20 27 7,20 34 3,23 34 3,26 34 1,26 35 1,26 36 1",
            "0 0 28,0 28 9,9 28 9,18 28 5,18 33 4,23 28 5,22 33 4,26 33 2,26 35 2",
            "0 0 17,17 0 12,17 12 5,0 17 20,20 17 2,22 12 7,20 19 9,20 28 9",
            "0 0 15,15 0 15,0 15 22,22 15 8,22 23 8,22 31 6,28 31 2,28 33 2,28 35 2",
            "0 0 31,0 31 6,6 31 6,12 31 6,18 31 6,24 31 3,24 34 3,27 31 4,27 35 2,29 35 2",
            "0 0 18,18 0 14,18 14 4,0 18 19,19 18 3,19 21 3,22 14 10,19 24 13",
            "0 0 22,0 22 15,22 0 11,22 11 11,15 22 9,15 31 6,24 22 9,21 31 6,27 31 6",
            "0 0 17,17 0 17,0 17 20,20 17 14,20 31 6,26 31 6,32 31 2,32 33 2,32 35 2",
            "0 0 18,18 0 17,18 17 1,0 18 19,19 17 16,19 33 4,23 33 4,27 33 4,31 33 4",
            "0 0 26,0 26 11,11 26 11,22 26 4,26 0 10,26 10 10,26 20 10,22 30 7,29 30 7",
            "0 0 37"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 2,2 36 1,2 37 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 2,2 36 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 3,3 35 2,3 37 1,4 37 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 2,2 36 2,4 36 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 3,3 35 3,6 35 1,6 36 1,6 37 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 6,6 32 2,6 34 2,6 36 2",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 2,2 36 2,4 36 2,6 36 2,8 36 1,8 37 1",
            "0 0 10,0 10 10,0 20 10,0 30 8,8 30 2,8 32 2,8 34 2,8 36 2",
            "0 0 11,0 11 11,0 22 11,0 33 5,5 33 3,5 36 2,8 33 3,7 36 2,9 36 2",
            "0 0 12,0 12 12,0 24 6,6 24 6,0 30 8,8 30 4,8 34 4",
            "0 0 13,0 13 13,0 26 4,0 30 4,0 34 4,4 26 9,4 35 3,7 35 3,10 35 3",
            "0 0 14,0 14 14,0 28 10,10 28 4,10 32 4,10 36 2,12 36 2",
            "0 0 15,0 15 9,0 24 9,0 33 5,9 15 6,9 21 6,9 27 6,5 33 5,10 33 5",
            "0 0 16,0 16 16,0 32 6,6 32 6,12 32 4,12 36 2,14 36 2",
            "0 0 17,0 17 17,0 34 4,4 34 4,8 34 4,12 34 4,16 34 1,16 35 1,16 36 1,16 37 1",
            "0 0 18,0 18 10,0 28 10,10 18 8,10 26 8,10 34 4,14 34 4",
            "0 0 19,0 19 19",
            "0 0 20,0 20 10,0 30 8,10 20 10,8 30 8,16 30 4,16 34 4",
            "0 0 21,0 21 17,17 21 4,17 25 4,17 29 4,17 33 4,17 37 1,18 37 1,19 37 1,20 37 1",
            "0 0 22,0 22 16,16 22 6,16 28 6,16 34 4,20 34 2,20 36 2",
            "0 0 23,0 23 9,0 32 6,9 23 9,6 32 6,12 32 6,18 23 5,18 28 5,18 33 5",
            "0 0 24,0 24 14,14 24 10,14 34 4,18 34 4,22 34 2,22 36 2",
            "0 0 25,0 25 13,13 25 4,17 25 4,21 25 4,13 29 9,22 29 3,22 32 3,22 35 3",
            "0 0 26,0 26 12,12 26 6,12 32 6,18 26 8,18 34 4,22 34 4",
            "0 0 27,0 27 11,11 27 11,22 27 5,22 32 3,22 35 3,25 32 2,25 34 2,25 36 2",
            "0 0 14,0 14 12,0 26 12,14 0 14,12 14 16,12 30 8,20 30 8",
            "0 0 29,0 29 9,9 29 9,18 29 9,27 29 2,27 31 2,27 33 2,27 35 2,27 37 1,28 37 1",
            "0 0 20,0 20 18,20 0 10,20 10 10,18 20 12,18 32 6,24 32 6",
            "0 0 19,0 19 19,19 0 12,19 12 12,19 24 6,25 24 6,19 30 8,27 30 4,27 34 4",
            "0 0 18,18 0 14,18 14 2,18 16 2,0 18 20,20 14 12,20 26 12",
            "0 0 19,0 19 19,19 0 14,19 14 14,19 28 10,29 28 4,29 32 4,29 36 2,31 36 2",
            "0 0 24,0 24 14,24 0 10,24 10 10,24 20 4,14 24 14,28 20 6,28 26 6,28 32 6",
            "0 0 19,0 19 19,19 0 16,19 16 16,19 32 6,25 32 6,31 32 4,31 36 2,33 36 2",
            "0 0 22,0 22 16,16 22 6,22 0 14,22 14 14,16 28 10,26 28 10",
            "0 0 19,0 19 19,19 0 18,19 18 10,19 28 10,29 18 8,29 26 8,29 34 4,33 34 4",
            "0 0 38"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 1,1 38 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 3,3 36 1,3 37 1,3 38 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 4,4 35 1,4 36 1,4 37 1,4 38 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 3,3 36 3",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 4,4 35 3,4 38 1,5 38 1,6 38 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 4,0 36 3,4 32 4,3 36 3,6 36 2,6 38 1,7 38 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 3,3 36 3,6 36 3",
            "0 0 10,0 10 10,0 20 10,0 30 5,0 35 4,5 30 5,4 35 4,8 35 2,8 37 2",
            "0 0 11,0 11 11,0 22 11,0 33 6,6 33 3,6 36 3,9 33 2,9 35 2,9 37 2",
            "0 0 12,0 12 12,0 24 12,0 36 3,3 36 3,6 36 3,9 36 3",
            "0 0 13,0 13 13,0 26 13",
            "0 0 14,0 14 14,0 28 11,11 28 3,11 31 3,11 34 3,11 37 2,13 37 1,13 38 1",
            "0 0 15,0 15 15,0 30 9,9 30 6,9 36 3,12 36 3",
            "0 0 16,0 16 16,0 32 7,7 32 7,14 32 2,14 34 2,14 36 2,14 38 1,15 38 1",
            "0 0 17,0 17 17,0 34 5,5 34 5,10 34 5,15 34 2,15 36 2,15 38 1,16 38 1",
            "0 0 18,0 18 9,9 18 9,0 27 12,12 27 6,12 33 6",
            "0 0 19,0 19 15,0 34 5,5 34 5,10 34 5,15 19 4,15 23 4,15 27 4,15 31 4,15 35 4",
            "0 0 12,0 12 12,12 0 8,12 8 8,12 16 8,0 24 15,15 24 5,15 29 5,15 34 5",
            "0 0 21,0 21 9,0 30 9,9 21 12,9 33 6,15 33 6",
            "0 0 22,0 22 17,17 22 5,17 27 5,17 32 5,17 37 2,19 37 2,21 37 1,21 38 1",
            "0 0 23,0 23 16,16 23 7,16 30 7,16 37 2,18 37 2,20 37 2,22 37 1,22 38 1",
            "0 0 24,0 24 15,15 24 9,15 33 6,21 33 3,21 36 3",
            "0 0 25,0 25 14,14 25 11,14 36 3,17 36 3,20 36 3,23 36 2,23 38 1,24 38 1",
            "0 0 26,0 26 13,13 26 13",
            "0 0 27,0 27 12,12 27 12,24 27 3,24 30 3,24 33 3,24 36 3",
            "0 0 28,0 28 11,11 28 11,22 28 6,22 34 3,22 37 2,25 34 3,24 37 2,26 37 2",
            "0 0 29,0 29 10,10 29 10,20 29 5,20 34 5,25 29 4,25 33 4,25 37 2,27 37 2",
            "0 0 30,0 30 9,9 30 9,18 30 9,27 30 3,27 33 3,27 36 3",
            "0 0 13,0 13 13,0 26 13,13 0 18,13 18 9,22 18 9,13 27 12,25 27 6,25 33 6",
            "0 0 32,0 32 7,7 32 7,14 32 7,21 32 7,28 32 4,28 36 3,31 36 1,31 37 1,31 38 1",
            "0 0 18,18 0 15,18 15 3,0 18 21,21 15 12,21 27 12",
            "0 0 17,17 0 17,0 17 22,22 17 12,22 29 6,22 35 4,28 29 6,26 35 4,30 35 4",
            "0 0 14,14 0 14,0 14 25,28 0 7,28 7 7,25 14 10,25 24 10,25 34 5,30 34 5",
            "0 0 12,12 0 12,24 0 12,0 12 27,27 12 9,27 21 9,27 30 9",
            "0 0 13,0 13 13,0 26 13,13 0 24,13 24 15,28 24 9,28 33 6,34 33 3,34 36 3",
            "0 0 19,19 0 19,0 19 20,20 19 10,20 29 10,30 19 8,30 27 8,30 35 4,34 35 4",
            "0 0 39"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 1,1 39 1,2 39 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 4,4 36 2,4 38 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 5,5 35 2,5 37 2,5 39 1,6 39 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 4,4 36 4,8 36 1,8 37 1,8 38 1,8 39 1",
            "0 0 10,0 10 10,0 20 10,0 30 10",
            "0 0 11,0 11 11,0 22 11,0 33 7,7 33 4,7 37 3,10 37 1,10 38 1,10 39 1",
            "0 0 12,0 12 12,0 24 12,0 36 4,4 36 4,8 36 4",
            "0 0 13,0 13 13,0 26 7,0 33 7,7 26 6,7 32 6,7 38 2,9 38 2,11 38 2",
            "0 0 14,0 14 14,0 28 6,0 34 6,6 28 8,6 36 4,10 36 4",
            "0 0 15,0 15 15,0 30 10,10 30 5,10 35 5",
            "0 0 16,0 16 16,0 32 8,8 32 8",
            "0 0 17,0 17 17,0 34 6,6 34 6,12 34 3,12 37 3,15 34 2,15 36 2,15 38 2",
            "0 0 18,0 18 18,0 36 4,4 36 4,8 36 4,12 36 4,16 36 2,16 38 2",
            "0 0 19,0 19 10,10 19 9,10 28 1,0 29 11,11 28 8,11 36 4,15 36 4",
            "0 0 20,0 20 20",
            "0 0 21,0 21 10,0 31 9,9 31 1,10 21 11,9 32 8,17 32 4,17 36 4",
            "0 0 22,0 22 18,18 22 4,18 26 4,18 30 4,18 34 4,18 38 2,20 38 2",
            "0 0 23,0 23 17,17 23 6,17 29 6,17 35 3,17 38 2,20 35 3,19 38 2,21 38 2",
            "0 0 24,0 24 16,16 24 8,16 32 8",
            "0 0 25,0 25 15,15 25 10,15 35 5,20 35 5",
            "0 0 26,0 26 14,14 26 6,20 26 6,14 32 8,22 32 4,22 36 4",
            "0 0 27,0 27 13,13 27 7,13 34 6,20 27 7,19 34 6,25 34 2,25 36 2,25 38 2",
            "0 0 28,0 28 12,12 28 12,24 28 4,24 32 4,24 36 4",
            "0 0 13,0 13 10,10 13 3,13 0 16,10 16 7,0 23 17,17 16 12,17 28 12",
            "0 0 30,0 30 10,10 30 10,20 30 10",
            "0 0 16,0 16 16,0 32 8,8 32 8,16 0 15,16 15 15,16 30 10,26 30 5,26 35 5",
            "0 0 32,0 32 8,8 32 8,16 32 8,24 32 8",
            "0 0 22,0 22 18,22 0 11,22 11 11,18 22 9,18 31 9,27 22 6,27 28 6,27 34 6",
            "0 0 18,18 0 16,18 16 2,20 16 2,0 18 22,22 16 12,22 28 12",
            "0 0 20,0 20 20,20 0 15,20 15 15,20 30 10,30 30 5,30 35 5",
            "0 0 20,0 20 20,20 0 16,20 16 16,20 32 8,28 32 8",
            "0 0 26,0 26 14,26 0 11,26 11 11,26 22 2,26 24 2,14 26 14,28 22 9,28 31 9",
            "0 0 30,0 30 10,10 30 10,20 30 10,30 0 8,30 8 8,30 16 8,30 24 8,30 32 8",
            "0 0 24,0 24 16,16 24 8,16 32 8,24 0 15,24 15 15,24 30 10,34 30 5,34 35 5",
            "0 0 40"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 1,1 40 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 2,2 39 1,2 40 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 1,1 40 1,2 40 1,3 40 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 3,0 38 3,3 35 2,3 37 2,3 39 2",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 3,0 39 2,3 36 3,2 39 2,4 39 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 3,0 38 3,3 35 4,3 39 2,5 39 2",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 4,4 32 4,0 36 5,5 36 3,5 39 2,7 39 1,7 40 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 5,5 36 4,5 40 1,6 40 1,7 40 1,8 40 1",
            "0 0 10,0 10 10,0 20 10,0 30 5,5 30 5,0 35 6,6 35 4,6 39 2,8 39 2",
            "0 0 11,0 11 11,0 22 11,0 33 8,8 33 3,8 36 3,8 39 2,10 39 1,10 40 1",
            "0 0 12,0 12 12,0 24 12,0 36 5,5 36 5,10 36 2,10 38 2,10 40 1,11 40 1",
            "0 0 13,0 13 13,0 26 10,0 36 5,5 36 5,10 26 3,10 29 3,10 32 3,10 35 3,10 38 3",
            "0 0 14,0 14 14,0 28 7,0 35 6,7 28 7,6 35 6,12 35 2,12 37 2,12 39 2",
            "0 0 15,0 15 15,0 30 11,11 30 4,11 34 4,11 38 3,14 38 1,14 39 1,14 40 1",
            "0 0 16,0 16 16,0 32 9,9 32 7,9 39 2,11 39 2,13 39 2,15 39 1,15 40 1",
            "0 0 17,0 17 17,0 34 7,7 34 7,14 34 3,14 37 3,14 40 1,15 40 1,16 40 1",
            "0 0 18,0 18 18,0 36 5,5 36 5,10 36 5,15 36 3,15 39 2,17 39 1,17 40 1",
            "0 0 19,0 19 11,0 30 11,11 19 8,11 27 8,11 35 6,17 35 2,17 37 2,17 39 2",
            "0 0 20,0 20 14,0 34 7,7 34 7,14 20 6,14 26 6,14 32 6,14 38 3,17 38 3",
            "0 0 21,0 21 14,0 35 6,6 35 6,14 21 7,14 28 7,12 35 6,18 35 3,18 38 3",
            "0 0 22,0 22 11,0 33 8,11 22 11,8 33 8,16 33 6,16 39 2,18 39 2,20 39 2",
            "0 0 23,0 23 18,18 23 5,18 28 5,18 33 5,18 38 3,21 38 2,21 40 1,22 40 1",
            "0 0 24,0 24 17,17 24 7,17 31 7,17 38 3,20 38 3,23 38 1,23 39 1,23 40 1",
            "0 0 25,0 25 16,16 25 9,16 34 7,23 34 2,23 36 2,23 38 2,23 40 1,24 40 1",
            "0 0 26,0 26 15,15 26 11,15 37 4,19 37 4,23 37 3,23 40 1,24 40 1,25 40 1",
            "0 0 27,0 27 14,14 27 7,14 34 7,21 27 6,21 33 6,21 39 2,23 39 2,25 39 2",
            "0 0 21,0 21 20,21 0 7,21 7 7,21 14 7,20 21 8,20 29 8,20 37 4,24 37 4",
            "0 0 29,0 29 12,12 29 12,24 29 5,24 34 5,24 39 2,26 39 2,28 39 1,28 40 1",
            "0 0 30,0 30 11,11 30 11,22 30 8,22 38 3,25 38 3,28 38 2,28 40 1,29 40 1",
            "0 0 31,0 31 10,10 31 10,20 31 5,20 36 5,25 31 6,25 37 4,29 37 2,29 39 2",
            "0 0 15,0 15 15,0 30 11,11 30 4,15 0 17,15 17 17,11 34 7,18 34 7,25 34 7",
            "0 0 11,11 0 11,0 11 15,0 26 15,22 0 11,15 11 18,15 29 12,27 29 6,27 35 6",
            "0 0 17,17 0 17,0 17 24,24 17 10,24 27 10,24 37 4,28 37 4,32 37 2,32 39 2",
            "0 0 21,0 21 20,21 0 14,21 14 7,28 14 7,20 21 15,20 36 5,25 36 5,30 36 5",
            "0 0 18,18 0 18,0 18 23,23 18 13,23 31 10,33 31 3,33 34 3,33 37 3,33 40 1,34 40 1,35 40 1",
            "0 0 20,20 0 17,20 17 1,20 18 1,20 19 1,0 20 21,21 17 16,21 33 8,29 33 8",
            "0 0 19,19 0 19,0 19 22,22 19 16,22 35 6,28 35 6,34 35 4,34 39 2,36 39 2",
            "0 0 26,0 26 15,26 0 13,26 13 13,15 26 15,30 26 9,30 35 6,36 35 3,36 38 3",
            "0 0 16,16 0 16,0 16 25,32 0 8,32 8 8,25 16 15,25 31 10,35 31 5,35 36 5",
            "0 0 41"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 2,2 40 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 2,2 40 2,4 40 1,4 41 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 2,2 40 2,4 40 2,6 40 2",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 6,6 36 3,6 39 3",
            "0 0 10,0 10 10,0 20 10,0 30 6,0 36 6,6 30 4,6 34 4,6 38 4",
            "0 0 11,0 11 11,0 22 11,0 33 9,9 33 2,9 35 2,9 37 2,9 39 2,9 41 1,10 41 1",
            "0 0 12,0 12 12,0 24 12,0 36 6,6 36 6",
            "0 0 13,0 13 13,0 26 13,0 39 3,3 39 3,6 39 3,9 39 3,12 39 1,12 40 1,12 41 1",
            "0 0 14,0 14 14,0 28 14",
            "0 0 15,0 15 15,0 30 12,12 30 3,12 33 3,12 36 3,12 39 3",
            "0 0 16,0 16 16,0 32 10,10 32 6,10 38 4,14 38 2,14 40 2",
            "0 0 17,0 17 17,0 34 8,8 34 4,8 38 4,12 34 5,12 39 3,15 39 2,15 41 1,16 41 1",
            "0 0 18,0 18 18,0 36 6,6 36 6,12 36 6",
            "0 0 19,0 19 19,0 38 4,4 38 4,8 38 4,12 38 4,16 38 3,16 41 1,17 41 1,18 41 1",
            "0 0 20,0 20 10,10 20 10,0 30 12,12 30 8,12 38 4,16 38 4",
            "0 0 21,0 21 21",
            "0 0 22,0 22 10,0 32 10,10 22 12,10 34 8,18 34 4,18 38 4",
            "0 0 23,0 23 19,19 23 4,19 27 4,19 31 4,19 35 4,19 39 3,22 39 1,22 40 1,22 41 1",
            "0 0 24,0 24 18,18 24 6,18 30 6,18 36 6",
            "0 0 25,0 25 17,17 25 8,17 33 4,21 33 4,17 37 5,22 37 3,22 40 2,24 40 1,24 41 1",
            "0 0 26,0 26 16,16 26 10,16 36 6,22 36 4,22 40 2,24 40 2",
            "0 0 27,0 27 15,15 27 12,15 39 3,18 39 3,21 39 3,24 39 3",
            "0 0 28,0 28 14,14 28 14",
            "0 0 29,0 29 13,13 29 13,26 29 3,26 32 3,26 35 3,26 38 3,26 41 1,27 41 1,28 41 1",
            "0 0 30,0 30 12,12 30 12,24 30 6,24 36 6",
            "0 0 31,0 31 11,11 31 11,22 31 9,22 40 2,24 40 2,26 40 2,28 40 2,30 40 1,30 41 1",
            "0 0 32,0 32 10,10 32 10,20 32 6,20 38 4,26 32 6,24 38 4,28 38 4",
            "0 0 33,0 33 9,9 33 9,18 33 9,27 33 6,27 39 3,30 39 3",
            "0 0 34,0 34 8,8 34 8,16 34 8,24 34 8,32 34 2,32 36 2,32 38 2,32 40 2",
            "0 0 21,0 21 21,21 0 14,21 14 14,21 28 14",
            "0 0 18,18 0 18,0 18 24,24 18 12,24 30 12",
            "0 0 21,0 21 21,21 0 16,21 16 16,21 32 10,31 32 6,31 38 4,35 38 2,35 40 2",
            "0 0 20,20 0 18,20 18 2,0 20 22,22 18 16,22 34 8,30 34 8",
            "0 0 21,0 21 21,21 0 18,21 18 18,21 36 6,27 36 6,33 36 6",
            "0 0 28,0 28 14,14 28 14,28 0 12,28 12 12,28 24 12,28 36 6,34 36 6",
            "0 0 21,0 21 21,21 0 20,21 20 10,31 20 10,21 30 12,33 30 8,33 38 4,37 38 4",
            "0 0 42"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 1,1 42 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 1,1 42 1,2 42 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 3,3 40 1,3 41 1,3 42 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 3,3 40 2,3 42 1,4 42 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 3,3 36 3,0 39 4,4 39 2,4 41 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 4,0 39 4,4 35 3,4 38 3,4 41 2,6 41 1,6 42 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 3,3 40 3,6 40 2,6 42 1,7 42 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 7,7 36 2,7 38 2,7 40 2,7 42 1,8 42 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 3,3 40 3,6 40 3,9 40 1,9 41 1,9 42 1",
            "0 0 11,0 11 11,0 22 11,0 33 5,0 38 5,5 33 6,5 39 4,9 39 2,9 41 2",
            "0 0 12,0 12 12,0 24 12,0 36 7,7 36 5,7 41 2,9 41 2,11 41 1,11 42 1",
            "0 0 13,0 13 13,0 26 13,0 39 4,4 39 4,8 39 4,12 39 1,12 40 1,12 41 1,12 42 1",
            "0 0 14,0 14 14,0 28 7,7 28 7,0 35 8,8 35 6,8 41 2,10 41 2,12 41 2",
            "0 0 15,0 15 9,0 24 9,9 15 6,9 21 6,9 27 6,0 33 10,10 33 5,10 38 5",
            "0 0 16,0 16 16,0 32 11,11 32 5,11 37 3,11 40 3,14 37 2,14 39 2,14 41 2",
            "0 0 17,0 17 17,0 34 9,9 34 4,13 34 4,9 38 5,14 38 3,14 41 2,16 41 1,16 42 1",
            "0 0 18,0 18 18,0 36 7,7 36 7,14 36 4,14 40 3,17 40 1,17 41 1,17 42 1",
            "0 0 19,0 19 19,0 38 5,5 38 5,10 38 5,15 38 4,15 42 1,16 42 1,17 42 1,18 42 1",
            "0 0 20,0 20 15,0 35 8,15 20 5,15 25 5,15 30 5,8 35 8,16 35 4,16 39 4",
            "0 0 21,0 21 7,7 21 7,14 21 7,0 28 15,15 28 6,15 34 6,15 40 3,18 40 3",
            "0 0 22,0 22 7,0 29 7,0 36 7,7 22 15,7 37 6,13 37 6,19 37 3,19 40 3",
            "0 0 23,0 23 15,0 38 5,5 38 5,10 38 5,15 23 8,15 31 8,15 39 4,19 39 4",
            "0 0 13,0 13 13,13 0 11,13 11 11,13 22 4,0 26 17,17 22 7,17 29 7,17 36 7",
            "0 0 25,0 25 18,18 25 7,18 32 7,18 39 4,22 39 3,22 42 1,23 42 1,24 42 1",
            "0 0 26,0 26 17,17 26 9,17 35 4,17 39 4,21 35 5,21 40 3,24 40 2,24 42 1,25 42 1",
            "0 0 27,0 27 16,16 27 11,16 38 5,21 38 3,21 41 2,24 38 3,23 41 2,25 41 2",
            "0 0 28,0 28 9,0 37 6,9 28 9,6 37 6,12 37 6,18 28 10,18 38 5,23 38 5",
            "0 0 29,0 29 14,14 29 7,14 36 7,21 29 8,21 37 6,27 37 2,27 39 2,27 41 2",
            "0 0 15,0 15 14,0 29 14,15 0 15,14 15 16,14 31 12,26 31 4,26 35 4,26 39 4",
            "0 0 31,0 31 12,12 31 12,24 31 7,24 38 5,29 38 2,29 40 2,29 42 1,30 42 1",
            "0 0 32,0 32 11,11 32 11,22 32 5,27 32 5,22 37 6,28 37 4,28 41 2,30 41 2",
            "0 0 22,0 22 21,22 0 11,22 11 11,21 22 12,21 34 9,30 34 3,30 37 3,30 40 3",
            "0 0 15,0 15 15,0 30 13,15 0 19,15 19 11,13 30 13,26 19 8,26 27 8,26 35 8",
            "0 0 35,0 35 8,8 35 8,16 35 8,24 35 8,32 35 3,32 38 3,32 41 2,34 41 1,34 42 1",
            "0 0 27,0 27 16,27 0 9,27 9 9,27 18 9,16 27 16,32 27 4,32 31 4,32 35 4,32 39 4",
            "0 0 10,0 10 10,0 20 10,10 0 27,10 27 3,0 30 13,13 27 16,29 27 8,29 35 8",
            "0 0 19,19 0 19,0 19 24,24 19 14,24 33 10,34 33 4,34 37 4,34 41 2,36 41 2",
            "0 0 20,20 0 19,20 19 1,21 19 1,22 19 1,0 20 23,23 19 16,23 35 8,31 35 8",
            "0 0 21,21 0 19,21 19 1,21 20 1,0 21 22,22 19 18,22 37 6,28 37 6,34 37 6",
            "0 0 14,14 0 14,28 0 13,28 13 1,0 14 29,29 13 12,29 25 12,29 37 6,35 37 6",
            "0 0 21,21 0 21,0 21 22,22 21 10,32 21 10,22 31 12,34 31 8,34 39 4,38 39 4",
            "0 0 43"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 2,2 42 1,2 43 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 4,4 40 1,4 41 1,4 42 1,4 43 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 2,2 42 2,4 42 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 2,2 42 2,4 42 2,6 42 1,6 43 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 4,4 40 4",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 4,0 40 4,4 36 5,4 41 3,7 41 2,7 43 1,8 43 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 4,4 40 4,8 40 2,8 42 2",
            "0 0 11,0 11 11,0 22 11,0 33 11",
            "0 0 12,0 12 12,0 24 12,0 36 8,8 36 4,8 40 4",
            "0 0 13,0 13 13,0 26 13,0 39 5,5 39 5,10 39 3,10 42 2,12 42 1,12 43 1",
            "0 0 14,0 14 14,0 28 8,0 36 8,8 28 6,8 34 6,8 40 4,12 40 2,12 42 2",
            "0 0 15,0 15 15,0 30 7,0 37 7,7 30 8,7 38 6,13 38 2,13 40 2,13 42 2",
            "0 0 16,0 16 16,0 32 12,12 32 4,12 36 4,12 40 4",
            "0 0 17,0 17 17,0 34 10,10 34 7,10 41 3,13 41 3,16 41 1,16 42 1,16 43 1",
            "0 0 18,0 18 18,0 36 8,8 36 8,16 36 2,16 38 2,16 40 2,16 42 2",
            "0 0 19,0 19 19,0 38 6,6 38 6,12 38 3,12 41 3,15 38 4,15 42 2,17 42 2",
            "0 0 20,0 20 12,0 32 12,12 20 8,12 28 8,12 36 8",
            "0 0 21,0 21 14,0 35 9,14 21 7,14 28 7,9 35 9,18 35 3,18 38 3,18 41 3",
            "0 0 22,0 22 22",
            "0 0 23,0 23 14,0 37 7,7 37 7,14 23 9,14 32 9,14 41 3,17 41 3,20 41 3",
            "0 0 24,0 24 12,0 36 8,12 24 12,8 36 8,16 36 8",
            "0 0 25,0 25 19,19 25 6,19 31 6,19 37 3,22 37 3,19 40 4,23 40 2,23 42 2",
            "0 0 26,0 26 18,18 26 8,18 34 8,18 42 2,20 42 2,22 42 2,24 42 2",
            "0 0 27,0 27 17,17 27 10,17 37 7,24 37 3,24 40 3,24 43 1,25 43 1,26 43 1",
            "0 0 28,0 28 16,16 28 12,16 40 4,20 40 4,24 40 4",
            "0 0 29,0 29 15,15 29 7,22 29 7,15 36 8,23 36 6,23 42 2,25 42 2,27 42 2",
            "0 0 20,20 0 10,20 10 10,0 20 24,24 20 6,24 26 6,24 32 6,24 38 6",
            "0 0 31,0 31 13,13 31 13,26 31 5,26 36 5,26 41 3,29 41 2,29 43 1,30 43 1",
            "0 0 32,0 32 12,12 32 12,24 32 8,24 40 4,28 40 4",
            "0 0 33,0 33 11,11 33 11,22 33 11",
            "0 0 34,0 34 10,10 34 10,20 34 10,30 34 4,30 38 4,30 42 2,32 42 2",
            "0 0 15,0 15 15,0 30 14,15 0 20,15 20 10,25 20 10,14 30 14,28 30 7,28 37 7",
            "0 0 36,0 36 8,8 36 8,16 36 8,24 36 8,32 36 4,32 40 4",
            "0 0 21,21 0 16,21 16 2,21 18 2,21 20 1,22 20 1,0 21 23,23 16 14,23 30 14",
            "0 0 22,0 22 22,22 0 16,22 16 16,22 32 12,34 32 4,34 36 4,34 40 4",
            "0 0 26,0 26 18,26 0 13,26 13 13,18 26 9,18 35 9,27 26 12,27 38 6,33 38 6",
            "0 0 20,20 0 20,0 20 24,24 20 16,24 36 8,32 36 8",
            "0 0 21,21 0 20,21 20 1,22 20 1,0 21 23,23 20 18,23 38 6,29 38 6,35 38 6",
            "0 0 14,14 0 14,28 0 14,0 14 30,30 14 12,30 26 12,30 38 6,36 38 6",
            "0 0 26,0 26 18,18 26 8,26 0 17,26 17 17,18 34 10,28 34 10,38 34 5,38 39 5",
            "0 0 44"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 1,1 44 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 1,1 44 1,2 44 1,3 44 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 3,3 42 3",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 3,3 42 3,6 42 1,6 43 1,6 44 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 5,5 40 3,5 43 2,7 43 1,7 44 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 5,5 40 5",
            "0 0 11,0 11 11,0 22 11,0 33 8,0 41 4,4 41 4,8 33 3,8 36 3,8 39 3,8 42 3",
            "0 0 12,0 12 12,0 24 12,0 36 9,9 36 3,9 39 3,9 42 3",
            "0 0 13,0 13 13,0 26 13,0 39 6,6 39 3,6 42 3,9 39 4,9 43 2,11 43 2",
            "0 0 14,0 14 14,0 28 7,7 28 7,0 35 10,10 35 4,10 39 4,10 43 2,12 43 2",
            "0 0 15,0 15 15,0 30 15",
            "0 0 16,0 16 16,0 32 13,13 32 3,13 35 3,13 38 3,13 41 3,13 44 1,14 44 1,15 44 1",
            "0 0 17,0 17 17,0 34 11,11 34 6,11 40 3,11 43 2,14 40 3,13 43 2,15 43 2",
            "0 0 18,0 18 18,0 36 9,9 36 9",
            "0 0 19,0 19 19,0 38 7,7 38 7,14 38 5,14 43 2,16 43 2,18 43 1,18 44 1",
            "0 0 20,0 20 20,0 40 5,5 40 5,10 40 5,15 40 5",
            "0 0 21,0 21 12,0 33 12,12 21 9,12 30 9,12 39 6,18 39 3,18 42 3",
            "0 0 22,0 22 11,11 22 11,0 33 12,12 33 6,12 39 6,18 33 4,18 37 4,18 41 4",
            "0 0 23,0 23 11,0 34 11,11 23 12,11 35 6,11 41 4,17 35 6,15 41 4,19 41 4",
            "0 0 24,0 24 12,0 36 9,12 24 12,9 36 9,18 36 6,18 42 3,21 42 3",
            "0 0 25,0 25 20,20 25 5,20 30 5,20 35 5,20 40 5",
            "0 0 26,0 26 19,19 26 7,19 33 7,19 40 5,24 40 2,24 42 2,24 44 1,25 44 1",
            "0 0 27,0 27 18,18 27 9,18 36 9",
            "0 0 28,0 28 17,17 28 11,17 39 6,23 39 3,23 42 3,26 39 2,26 41 2,26 43 2",
            "0 0 29,0 29 16,16 29 13,16 42 3,19 42 3,22 42 3,25 42 3,28 42 1,28 43 1,28 44 1",
            "0 0 30,0 30 15,15 30 15",
            "0 0 31,0 31 14,14 31 7,14 38 7,21 31 10,21 41 4,25 41 4,29 41 2,29 43 2",
            "0 0 32,0 32 13,13 32 13,26 32 6,26 38 3,29 38 3,26 41 4,30 41 2,30 43 2",
            "0 0 33,0 33 12,12 33 12,24 33 9,24 42 3,27 42 3,30 42 3",
            "0 0 17,0 17 14,0 31 14,17 0 17,14 17 20,14 37 8,22 37 8,30 37 4,30 41 4",
            "0 0 35,0 35 10,10 35 10,20 35 10,30 35 5,30 40 5",
            "0 0 36,0 36 9,9 36 9,18 36 9,27 36 9",
            "0 0 26,0 26 19,19 26 7,26 0 11,26 11 11,26 22 11,19 33 12,31 33 6,31 39 6",
            "0 0 19,19 0 19,0 19 26,26 19 12,26 31 6,32 31 6,26 37 8,34 37 4,34 41 4",
            "0 0 30,0 30 15,15 30 15,30 0 9,30 9 9,30 18 9,30 27 9,30 36 9",
            "0 0 20,20 0 20,0 20 25,25 20 15,25 35 10,35 35 5,35 40 5",
            "0 0 28,0 28 17,17 28 11,17 39 6,28 0 13,28 13 13,28 26 13,23 39 6,29 39 6,35 39 6",
            "0 0 21,21 0 21,0 21 24,24 21 18,24 39 6,30 39 6,36 39 6",
            "0 0 22,22 0 21,22 21 1,0 22 23,23 21 12,23 33 12,35 21 8,35 29 8,35 37 8",
            "0 0 33,0 33 12,12 33 12,33 0 11,33 11 11,33 22 11,24 33 12,36 33 8,36 41 4,40 41 4",
            "0 0 45"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 1,1 45 1,2 45 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 2,2 44 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 3,0 43 3,3 40 2,3 42 2,3 44 2",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 4,4 42 2,4 44 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 4,4 42 3,4 45 1,5 45 1,6 45 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 6,6 40 2,6 42 2,6 44 2",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 5,0 41 5,5 36 4,5 40 4,5 44 2,7 44 2",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 6,6 40 4,6 44 2,8 44 2",
            "0 0 11,0 11 11,0 22 11,0 33 6,6 33 5,6 38 1,0 39 7,7 38 4,7 42 4",
            "0 0 12,0 12 12,0 24 12,0 36 6,0 42 4,6 36 6,4 42 4,8 42 4",
            "0 0 13,0 13 13,0 26 13,0 39 7,7 39 3,10 39 3,7 42 4,11 42 2,11 44 2",
            "0 0 14,0 14 14,0 28 14,0 42 4,4 42 4,8 42 4,12 42 2,12 44 2",
            "0 0 15,0 15 15,0 30 10,0 40 6,10 30 5,10 35 5,6 40 6,12 40 3,12 43 3",
            "0 0 16,0 16 16,0 32 8,0 40 6,8 32 8,6 40 6,12 40 4,12 44 2,14 44 2",
            "0 0 17,0 17 17,0 34 12,12 34 5,12 39 5,12 44 2,14 44 2,16 44 1,16 45 1",
            "0 0 18,0 18 18,0 36 10,10 36 8,10 44 2,12 44 2,14 44 2,16 44 2",
            "0 0 19,0 19 19,0 38 8,8 38 8,16 38 3,16 41 3,16 44 2,18 44 1,18 45 1",
            "0 0 20,0 20 20,0 40 6,6 40 6,12 40 6,18 40 2,18 42 2,18 44 2",
            "0 0 21,0 21 7,7 21 7,0 28 9,0 37 9,14 21 7,9 28 12,9 40 6,15 40 6",
            "0 0 22,0 22 16,0 38 8,8 38 8,16 22 6,16 28 6,16 34 6,16 40 6",
            "0 0 23,0 23 23",
            "0 0 24,0 24 16,0 40 6,6 40 6,16 24 8,16 32 8,12 40 6,18 40 6",
            "0 0 25,0 25 7,0 32 7,0 39 7,7 25 9,16 25 9,7 34 12,19 34 6,19 40 6",
            "0 0 26,0 26 20,20 26 6,20 32 6,20 38 6,20 44 2,22 44 2,24 44 2",
            "0 0 27,0 27 19,19 27 8,19 35 8,19 43 3,22 43 3,25 43 2,25 45 1,26 45 1",
            "0 0 28,0 28 18,18 28 10,18 38 8,26 38 2,26 40 2,26 42 2,26 44 2",
            "0 0 29,0 29 17,17 29 12,17 41 5,22 41 5,27 41 2,27 43 2,27 45 1,28 45 1",
            "0 0 18,0 18 18,0 36 10,18 0 12,18 12 12,18 24 12,10 36 10,20 36 10",
            "0 0 31,0 31 15,15 31 10,15 41 5,20 41 5,25 31 6,25 37 6,25 43 3,28 43 3",
            "0 0 32,0 32 14,14 32 14,28 32 4,28 36 4,28 40 4,28 44 2,30 44 2",
            "0 0 33,0 33 13,13 33 13,26 33 7,26 40 3,26 43 3,29 40 4,29 44 2,31 44 2",
            "0 0 34,0 34 12,12 34 12,24 34 6,24 40 6,30 34 4,30 38 4,30 42 4",
            "0 0 35,0 35 11,11 35 11,22 35 6,22 41 5,27 41 1,28 35 7,27 42 4,31 42 4",
            "0 0 36,0 36 10,10 36 10,20 36 10,30 36 6,30 42 4,34 42 2,34 44 2",
            "0 0 24,0 24 22,22 24 2,24 0 13,24 13 13,22 26 15,22 41 5,27 41 5,32 41 5",
            "0 0 38,0 38 8,8 38 8,16 38 8,24 38 8,32 38 6,32 44 2,34 44 2,36 44 2",
            "0 0 13,13 0 13,0 13 18,0 31 15,15 31 3,26 0 13,18 13 21,15 34 12,27 34 12",
            "0 0 30,0 30 16,30 0 10,30 10 10,30 20 10,16 30 16,32 30 8,32 38 8",
            "0 0 19,19 0 11,19 11 8,0 19 27,30 0 11,27 11 14,27 25 14,27 39 7,34 39 7",
            "0 0 28,0 28 18,28 0 14,28 14 14,18 28 18,36 28 6,36 34 6,36 40 6",
            "0 0 15,0 15 15,15 0 28,15 28 1,15 29 1,0 30 16,16 28 18,34 28 9,34 37 9",
            "0 0 22,22 0 22,0 22 24,24 22 12,24 34 12,36 22 8,36 30 8,36 38 8",
            "0 0 17,17 0 17,0 17 29,29 17 5,34 0 11,34 11 11,29 22 16,29 38 8,37 38 8",
            "0 0 46"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 1,1 46 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 2,2 45 1,2 46 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 3,3 44 1,3 45 1,3 46 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 2,2 45 2,4 45 1,4 46 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 3,0 45 2,3 42 3,2 45 2,4 45 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 5,5 42 2,5 44 2,5 46 1,6 46 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 4,0 44 3,4 40 4,3 44 3,6 44 2,6 46 1,7 46 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 2,2 45 2,4 45 2,6 45 2,8 45 1,8 46 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 7,7 40 3,7 43 3,7 46 1,8 46 1,9 46 1",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 3,3 44 3,6 44 3,9 44 2,9 46 1,10 46 1",
            "0 0 12,0 12 12,0 24 12,0 36 8,0 44 3,3 44 3,8 36 4,8 40 4,6 44 3,9 44 3",
            "0 0 13,0 13 13,0 26 13,0 39 8,8 39 5,8 44 3,11 44 2,11 46 1,12 46 1",
            "0 0 14,0 14 14,0 28 7,0 35 6,0 41 6,7 28 7,6 35 8,6 43 4,10 43 4",
            "0 0 15,0 15 15,0 30 8,8 30 7,8 37 1,0 38 9,9 37 6,9 43 4,13 43 2,13 45 2",
            "0 0 16,0 16 16,0 32 10,0 42 5,5 42 5,10 32 6,10 38 6,10 44 3,13 44 3",
            "0 0 17,0 17 17,0 34 13,13 34 4,13 38 4,13 42 4,13 46 1,14 46 1,15 46 1,16 46 1",
            "0 0 18,0 18 18,0 36 11,11 36 7,11 43 4,15 43 3,15 46 1,16 46 1,17 46 1",
            "0 0 19,0 19 19,0 38 9,9 38 5,9 43 4,14 38 5,13 43 4,17 43 2,17 45 2",
            "0 0 20,0 20 20,0 40 7,7 40 7,14 40 3,17 40 3,14 43 4,18 43 2,18 45 2",
            "0 0 21,0 21 14,0 35 12,14 21 7,14 28 7,12 35 9,12 44 3,15 44 3,18 44 3",
            "0 0 22,0 22 11,11 22 11,0 33 14,14 33 8,14 41 6,20 41 2,20 43 2,20 45 2",
            "0 0 23,0 23 8,0 31 8,0 39 8,8 23 15,8 38 9,17 38 6,17 44 3,20 44 3",
            "0 0 24,0 24 8,8 24 8,0 32 15,16 24 8,15 32 9,15 41 6,21 41 3,21 44 3",
            "0 0 25,0 25 11,0 36 11,11 25 14,11 39 8,19 39 6,19 45 2,21 45 2,23 45 2",
            "0 0 26,0 26 14,0 40 7,7 40 7,14 26 12,14 38 9,23 38 3,23 41 3,23 44 3",
            "0 0 27,0 27 20,20 27 7,20 34 7,20 41 3,20 44 3,23 41 4,23 45 2,25 45 2",
            "0 0 28,0 28 19,19 28 9,19 37 5,19 42 5,24 37 4,24 41 4,24 45 2,26 45 2",
            "0 0 29,0 29 18,18 29 11,18 40 7,25 40 4,25 44 3,28 44 1,28 45 1,28 46 1",
            "0 0 15,15 0 15,0 15 20,0 35 12,20 15 10,20 25 10,12 35 12,24 35 6,24 41 6",
            "0 0 31,0 31 16,16 31 10,16 41 6,26 31 5,26 36 5,22 41 6,28 41 3,28 44 3",
            "0 0 32,0 32 15,15 32 8,15 40 7,22 40 1,23 32 9,22 41 6,28 41 4,28 45 2,30 45 2",
            "0 0 33,0 33 14,14 33 7,14 40 7,21 33 6,27 33 6,21 39 8,29 39 4,29 43 4",
            "0 0 34,0 34 13,13 34 13,26 34 8,26 42 5,31 42 3,31 45 2,33 45 1,33 46 1",
            "0 0 17,0 17 17,0 34 13,13 34 2,15 34 2,17 0 18,17 18 18,13 36 11,24 36 11",
            "0 0 17,0 17 15,0 32 15,15 17 2,17 0 19,15 19 21,15 40 7,22 40 7,29 40 7",
            "0 0 14,0 14 14,14 0 23,14 23 5,0 28 19,19 23 18,19 41 6,25 41 6,31 41 6",
            "0 0 19,0 19 14,0 33 14,19 0 19,14 19 12,26 19 12,14 31 16,30 31 8,30 39 8",
            "0 0 26,0 26 21,26 0 13,26 13 13,21 26 9,30 26 9,21 35 12,33 35 6,33 41 6",
            "0 0 28,0 28 19,19 28 9,28 0 12,28 12 12,28 24 12,28 36 1,19 37 10,29 36 11",
            "0 0 22,22 0 19,22 19 3,0 22 25,25 19 16,25 35 12,37 35 4,37 39 4,37 43 4",
            "0 0 21,21 0 21,0 21 26,26 21 16,26 37 10,36 37 6,36 43 4,40 43 2,40 45 2",
            "0 0 30,0 30 17,30 0 13,30 13 13,30 26 4,17 30 17,34 26 9,34 35 9,34 44 3,37 44 3,40 44 3",
            "0 0 15,0 15 15,15 0 29,15 29 1,16 29 1,0 30 17,17 29 18,35 29 9,35 38 9",
            "0 0 28,0 28 19,19 28 6,25 28 3,25 31 3,28 0 17,28 17 17,19 34 13,32 34 13",
            "0 0 26,0 26 21,21 26 5,26 0 20,26 20 11,21 31 16,37 20 9,37 29 9,37 38 9",
            "0 0 47"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 3,3 45 2,3 47 1,4 47 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 3,0 45 3,3 42 4,3 46 2,5 46 2",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 3,3 45 3,6 45 3",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 8,8 40 2,8 42 2,8 44 2,8 46 2",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 4,4 44 4,8 44 3,8 47 1,9 47 1,10 47 1",
            "0 0 12,0 12 12,0 24 12,0 36 12",
            "0 0 13,0 13 13,0 26 13,0 39 9,9 39 4,9 43 4,9 47 1,10 47 1,11 47 1,12 47 1",
            "0 0 14,0 14 14,0 28 14,0 42 6,6 42 6,12 42 2,12 44 2,12 46 2",
            "0 0 15,0 15 15,0 30 9,0 39 9,9 30 6,9 36 6,9 42 6",
            "0 0 16,0 16 16,0 32 16",
            "0 0 17,0 17 17,0 34 7,0 41 7,7 34 10,7 44 4,11 44 4,15 44 2,15 46 2",
            "0 0 18,0 18 18,0 36 12,12 36 6,12 42 6",
            "0 0 19,0 19 19,0 38 10,10 38 5,10 43 5,15 38 4,15 42 4,15 46 2,17 46 2",
            "0 0 20,0 20 20,0 40 8,8 40 8,16 40 4,16 44 4",
            "0 0 21,0 21 21,0 42 6,6 42 6,12 42 6,18 42 3,18 45 3",
            "0 0 22,0 22 12,12 22 10,12 32 2,0 34 14,14 32 8,14 40 8",
            "0 0 23,0 23 8,8 23 8,16 23 7,16 30 1,0 31 17,17 30 6,17 36 6,17 42 6",
            "0 0 24,0 24 24",
            "0 0 25,0 25 8,0 33 8,0 41 7,7 41 1,8 25 17,7 42 6,13 42 6,19 42 6",
            "0 0 26,0 26 12,0 38 10,10 38 2,12 26 14,10 40 8,18 40 8",
            "0 0 27,0 27 21,21 27 6,21 33 6,21 39 6,21 45 3,24 45 3",
            "0 0 28,0 28 20,20 28 8,20 36 8,20 44 4,24 44 4",
            "0 0 29,0 29 19,19 29 10,19 39 5,19 44 4,24 39 5,23 44 4,27 44 2,27 46 2",
            "0 0 30,0 30 18,18 30 12,18 42 6,24 42 6",
            "0 0 31,0 31 17,17 31 7,24 31 7,17 38 10,27 38 4,27 42 4,27 46 2,29 46 2",
            "0 0 32,0 32 16,16 32 16",
            "0 0 33,0 33 15,15 33 9,15 42 6,24 33 9,21 42 6,27 42 6",
            "0 0 34,0 34 14,14 34 14,28 34 6,28 40 6,28 46 2,30 46 2,32 46 2",
            "0 0 35,0 35 13,13 35 13,26 35 9,26 44 4,30 44 4,34 44 1,34 45 1,34 46 1,34 47 1",
            "0 0 36,0 36 12,12 36 12,24 36 12",
            "0 0 37,0 37 11,11 37 11,22 37 11,33 37 4,33 41 4,33 45 3,36 45 1,36 46 1,36 47 1",
            "0 0 38,0 38 10,10 38 10,20 38 10,30 38 8,30 46 2,32 46 2,34 46 2,36 46 2",
            "0 0 39,0 39 9,9 39 9,18 39 9,27 39 9,36 39 3,36 42 3,36 45 3",
            "0 0 24,0 24 24,24 0 16,24 16 16,24 32 16",
            "0 0 13,0 13 13,0 26 11,0 37 11,11 26 2,13 0 28,11 28 20,31 28 10,31 38 10",
            "0 0 24,0 24 24,24 0 18,24 18 18,24 36 12,36 36 6,36 42 6",
            "0 0 26,0 26 22,22 26 4,22 30 4,26 0 17,26 17 17,22 34 14,36 34 7,36 41 7",
            "0 0 32,0 32 16,16 32 16,32 0 12,32 12 12,32 24 12,32 36 12",
            "0 0 30,0 30 18,30 0 15,30 15 15,18 30 18,36 30 9,36 39 9",
            "0 0 16,0 16 16,0 32 16,16 0 30,16 30 18,34 30 12,34 42 6,40 42 6",
            "0 0 32,0 32 16,16 32 16,32 0 15,32 15 15,32 30 9,32 39 9,41 30 6,41 36 6,41 42 6",
            "0 0 48"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 1,1 48 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 1,1 48 1,2 48 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 1,1 48 1,2 48 1,3 48 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 4,4 45 1,4 46 1,4 47 1,4 48 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 3,3 42 3,0 45 4,4 45 2,4 47 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 4,4 40 4,0 44 5,5 44 3,5 47 2,7 47 1,7 48 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 4,4 45 4,8 45 1,8 46 1,8 47 1,8 48 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 5,0 45 4,5 40 5,4 45 4,8 45 2,8 47 2",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 5,5 44 3,5 47 2,8 44 3,7 47 2,9 47 2",
            "0 0 12,0 12 12,0 24 12,0 36 4,4 36 4,8 36 4,0 40 9,9 40 3,9 43 3,9 46 3",
            "0 0 13,0 13 13,0 26 13,0 39 10,10 39 3,10 42 3,10 45 3,10 48 1,11 48 1,12 48 1",
            "0 0 14,0 14 14,0 28 14,0 42 7,7 42 7",
            "0 0 15,0 15 15,0 30 10,0 40 9,10 30 5,10 35 5,9 40 6,9 46 3,12 46 3",
            "0 0 16,0 16 16,0 32 10,0 42 7,7 42 3,10 32 6,10 38 6,10 44 1,7 45 4,11 44 5",
            "0 0 17,0 17 17,0 34 8,0 42 7,7 42 1,8 34 9,7 43 6,13 43 4,13 47 2,15 47 2",
            "0 0 18,0 18 18,0 36 13,13 36 5,13 41 5,13 46 3,16 46 2,16 48 1,17 48 1",
            "0 0 19,0 19 19,0 38 11,11 38 8,11 46 3,14 46 3,17 46 2,17 48 1,18 48 1",
            "0 0 20,0 20 20,0 40 9,9 40 9,18 40 2,18 42 2,18 44 2,18 46 2,18 48 1,19 48 1",
            "0 0 21,0 21 21,0 42 7,7 42 7,14 42 7",
            "0 0 22,0 22 11,11 22 11,0 33 16,16 33 6,16 39 6,16 45 4,20 45 2,20 47 2",
            "0 0 23,0 23 13,0 36 13,13 23 10,13 33 10,13 43 6,19 43 4,19 47 2,21 47 2",
            "0 0 24,0 24 16,0 40 9,16 24 8,16 32 8,9 40 9,18 40 6,18 46 3,21 46 3",
            "0 0 25,0 25 16,0 41 8,8 41 8,16 25 9,16 34 9,16 43 6,22 43 3,22 46 3",
            "0 0 26,0 26 13,0 39 10,13 26 13,10 39 10,20 39 6,20 45 4,24 45 2,24 47 2",
            "0 0 27,0 27 11,0 38 11,11 27 16,11 43 6,17 43 6,23 43 4,23 47 2,25 47 2",
            "0 0 28,0 28 21,21 28 7,21 35 7,21 42 7",
            "0 0 29,0 29 20,20 29 9,20 38 9,20 47 2,22 47 2,24 47 2,26 47 2,28 47 1,28 48 1",
            "0 0 30,0 30 19,19 30 11,19 41 8,27 41 3,27 44 3,27 47 2,29 47 1,29 48 1",
            "0 0 31,0 31 18,18 31 13,18 44 5,23 44 5,28 44 3,28 47 2,30 47 1,30 48 1",
            "0 0 32,0 32 17,17 32 8,25 32 7,25 39 1,17 40 9,26 39 6,26 45 4,30 45 2,30 47 2",
            "0 0 22,22 0 11,22 11 11,0 22 27,27 22 6,27 28 6,27 34 6,27 40 6,27 46 3,30 46 3",
            "0 0 34,0 34 15,15 34 10,15 44 5,20 44 5,25 34 9,25 43 6,31 43 3,31 46 3",
            "0 0 35,0 35 14,14 35 14,28 35 7,28 42 7",
            "0 0 17,0 17 16,0 33 16,16 17 1,16 18 1,17 0 19,16 19 20,16 39 10,26 39 10",
            "0 0 15,0 15 15,15 0 22,15 22 4,15 26 4,0 30 19,19 22 18,19 40 9,28 40 9",
            "0 0 19,19 0 19,0 19 20,0 39 10,10 39 10,20 19 18,20 37 12,32 37 6,32 43 6",
            "0 0 22,22 0 17,22 17 5,0 22 27,27 17 12,27 29 12,27 41 8,35 41 4,35 45 4",
            "0 0 24,24 0 16,24 16 8,0 24 25,32 16 8,25 24 15,25 39 10,35 39 5,35 44 5",
            "0 0 15,15 0 13,15 13 2,0 15 17,0 32 17,28 0 13,17 13 24,17 37 12,29 37 12",
            "0 0 21,21 0 21,0 21 28,28 21 14,28 35 14",
            "0 0 15,15 0 15,30 0 13,30 13 2,32 13 2,0 15 34,34 13 9,34 22 9,34 31 9,34 40 9",
            "0 0 33,0 33 16,16 33 16,33 0 11,33 11 11,33 22 11,32 33 12,32 45 4,36 45 4,40 45 4",
            "0 0 13,0 13 13,13 0 16,13 16 10,0 26 23,29 0 16,23 16 22,23 38 11,34 38 11",
            "0 0 29,0 29 20,20 29 9,29 0 17,29 17 17,29 34 2,29 36 2,20 38 11,31 34 15",
            "0 0 16,0 16 16,16 0 31,16 31 1,0 32 17,17 31 18,35 31 12,35 43 6,41 43 6",
            "0 0 30,0 30 19,19 30 11,19 41 8,30 0 18,30 18 18,30 36 5,27 41 8,35 36 13",
            "0 0 49"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 2,2 48 1,2 49 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 2,2 48 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 2,2 48 2,4 48 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 4,0 46 4,4 42 3,4 45 3,4 48 2,6 48 1,6 49 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 2,2 48 2,4 48 2,6 48 2",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 5,5 45 4,5 49 1,6 49 1,7 49 1,8 49 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 6,6 44 3,6 47 3,9 44 2,9 46 2,9 48 2",
            "0 0 12,0 12 12,0 24 12,0 36 6,6 36 6,0 42 8,8 42 4,8 46 4",
            "0 0 13,0 13 13,0 26 13,0 39 6,0 45 5,5 45 1,6 39 7,5 46 4,9 46 4",
            "0 0 14,0 14 14,0 28 14,0 42 8,8 42 6,8 48 2,10 48 2,12 48 2",
            "0 0 15,0 15 15,0 30 15,0 45 5,5 45 5,10 45 5",
            "0 0 16,0 16 16,0 32 8,8 32 8,0 40 10,10 40 6,10 46 4,14 46 2,14 48 2",
            "0 0 17,0 17 17,0 34 10,0 44 6,10 34 7,10 41 3,6 44 6,12 44 1,13 41 4,12 45 5",
            "0 0 18,0 18 18,0 36 14,14 36 4,14 40 4,14 44 4,14 48 2,16 48 2",
            "0 0 19,0 19 19,0 38 12,12 38 7,12 45 5,17 45 2,17 47 2,17 49 1,18 49 1",
            "0 0 20,0 20 20,0 40 10,10 40 10",
            "0 0 21,0 21 21,0 42 8,8 42 8,16 42 5,16 47 3,19 47 2,19 49 1,20 49 1",
            "0 0 22,0 22 22,0 44 6,6 44 6,12 44 6,18 44 4,18 48 2,20 48 2",
            "0 0 23,0 23 16,0 39 11,11 39 5,16 23 7,16 30 7,16 37 7,11 44 6,17 44 6",
            "0 0 24,0 24 8,8 24 8,16 24 8,0 32 18,18 32 6,18 38 6,18 44 6",
            "0 0 25,0 25 25",
            "0 0 26,0 26 8,0 34 8,0 42 8,8 26 18,8 44 6,14 44 6,20 44 6",
            "0 0 27,0 27 16,0 43 7,7 43 7,16 27 11,16 38 5,14 43 7,21 38 6,21 44 6",
            "0 0 28,0 28 22,22 28 6,22 34 6,22 40 6,22 46 4,26 46 2,26 48 2",
            "0 0 29,0 29 21,21 29 8,21 37 8,21 45 5,26 45 3,26 48 2,28 48 1,28 49 1",
            "0 0 30,0 30 20,20 30 10,20 40 10",
            "0 0 31,0 31 19,19 31 12,19 43 7,26 43 5,26 48 2,28 48 2,30 48 1,30 49 1",
            "0 0 32,0 32 18,18 32 14,18 46 4,22 46 4,26 46 4,30 46 2,30 48 2",
            "0 0 18,18 0 15,18 15 3,0 18 21,0 39 11,21 15 12,21 27 12,11 39 11,22 39 11",
            "0 0 34,0 34 16,16 34 8,16 42 8,24 34 10,24 44 6,30 44 4,30 48 2,32 48 2",
            "0 0 35,0 35 15,15 35 15,30 35 5,30 40 5,30 45 5",
            "0 0 36,0 36 14,14 36 14,28 36 8,28 44 6,34 44 2,34 46 2,34 48 2",
            "0 0 37,0 37 13,13 37 13,26 37 6,32 37 5,32 42 1,26 43 7,33 42 4,33 46 4",
            "0 0 38,0 38 12,12 38 12,24 38 6,24 44 6,30 38 8,30 46 4,34 46 4",
            "0 0 26,0 26 24,26 0 13,26 13 13,24 26 15,24 41 9,33 41 6,33 47 3,36 47 3",
            "0 0 40,0 40 10,10 40 10,20 40 10,30 40 10",
            "0 0 12,12 0 12,0 12 19,0 31 19,19 12 5,24 0 17,19 17 22,19 39 11,30 39 11",
            "0 0 14,14 0 14,0 14 18,0 32 18,28 0 14,18 14 24,18 38 12,30 38 12",
            "0 0 24,24 0 19,24 19 5,0 24 26,26 24 3,26 27 3,26 30 3,29 19 14,26 33 17",
            "0 0 22,22 0 22,0 22 28,28 22 16,28 38 12,40 38 4,40 42 4,40 46 4",
            "0 0 25,0 25 25,25 0 20,25 20 20,25 40 10,35 40 10",
            "0 0 16,16 0 16,32 0 14,32 14 2,0 16 34,34 14 12,34 26 12,34 38 12",
            "0 0 33,0 33 17,33 0 14,33 14 14,33 28 5,17 33 17,34 33 4,38 28 9,34 37 13",
            "0 0 32,0 32 18,32 0 16,32 16 16,18 32 18,36 32 12,36 44 6,42 44 6",
            "0 0 25,0 25 25,25 0 24,25 24 8,33 24 8,41 24 8,25 32 18,43 32 6,43 38 6,43 44 6",
            "0 0 50"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 1,1 50 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 3,3 48 1,3 49 1,3 50 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 3,0 48 3,3 45 2,3 47 2,3 49 2",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 3,3 48 3",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 2,2 49 2,4 49 2,6 49 1,6 50 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 3,3 48 3,6 48 2,6 50 1,7 50 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 6,6 45 3,6 48 3",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 5,5 40 5,0 45 6,6 45 4,6 49 2,8 49 2",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 7,7 44 4,7 48 3,10 48 1,10 49 1,10 50 1",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 3,3 48 3,6 48 3,9 48 3",
            "0 0 13,0 13 13,0 26 13,0 39 4,0 43 4,0 47 4,4 39 9,4 48 3,7 48 3,10 48 3",
            "0 0 14,0 14 14,0 28 14,0 42 9,9 42 5,9 47 4,13 47 1,13 48 1,13 49 1,13 50 1",
            "0 0 15,0 15 15,0 30 15,0 45 6,6 45 6,12 45 3,12 48 3",
            "0 0 16,0 16 16,0 32 9,9 32 7,9 39 1,9 40 1,0 41 10,10 39 6,10 45 6",
            "0 0 17,0 17 17,0 34 17",
            "0 0 18,0 18 18,0 36 9,0 45 6,9 36 9,6 45 6,12 45 6",
            "0 0 19,0 19 19,0 38 13,13 38 6,13 44 3,16 44 3,13 47 4,17 47 2,17 49 2",
            "0 0 20,0 20 20,0 40 11,11 40 9,11 49 2,13 49 2,15 49 2,17 49 2,19 49 1,19 50 1",
            "0 0 21,0 21 21,0 42 9,9 42 9,18 42 3,18 45 3,18 48 3",
            "0 0 22,0 22 11,11 22 11,0 33 18,18 33 4,18 37 4,18 41 4,18 45 4,18 49 2,20 49 2",
            "0 0 23,0 23 23,0 46 5,5 46 5,10 46 5,15 46 5,20 46 3,20 49 2,22 49 1,22 50 1",
            "0 0 24,0 24 12,12 24 12,0 36 15,15 36 9,15 45 6,21 45 3,21 48 3",
            "0 0 25,0 25 13,0 38 13,13 25 12,13 37 6,19 37 6,13 43 8,21 43 4,21 47 4",
            "0 0 26,0 26 13,0 39 12,13 26 13,12 39 6,12 45 6,18 39 8,18 47 4,22 47 4",
            "0 0 27,0 27 12,0 39 12,12 27 15,12 42 9,21 42 6,21 48 3,24 48 3",
            "0 0 28,0 28 23,23 28 5,23 33 5,23 38 5,23 43 5,23 48 3,26 48 2,26 50 1,27 50 1",
            "0 0 29,0 29 11,0 40 11,11 29 18,11 47 4,15 47 4,19 47 4,23 47 4,27 47 2,27 49 2",
            "0 0 30,0 30 21,21 30 9,21 39 9,21 48 3,24 48 3,27 48 3",
            "0 0 31,0 31 20,20 31 11,20 42 9,29 42 2,29 44 2,29 46 2,29 48 2,29 50 1,30 50 1",
            "0 0 32,0 32 19,19 32 13,19 45 6,25 45 3,25 48 3,28 45 4,28 49 2,30 49 2",
            "0 0 33,0 33 18,18 33 9,18 42 9,27 33 6,27 39 6,27 45 6",
            "0 0 34,0 34 17,17 34 17",
            "0 0 35,0 35 16,16 35 9,16 44 7,23 44 1,24 44 1,25 35 10,23 45 6,29 45 6",
            "0 0 36,0 36 15,15 36 15,30 36 6,30 42 6,30 48 3,33 48 3",
            "0 0 37,0 37 14,14 37 14,28 37 9,28 46 5,33 46 4,33 50 1,34 50 1,35 50 1,36 50 1",
            "0 0 19,0 19 18,0 37 14,14 37 2,16 37 2,19 0 19,18 19 20,14 39 12,26 39 12",
            "0 0 39,0 39 12,12 39 12,24 39 12,36 39 3,36 42 3,36 45 3,36 48 3",
            "0 0 40,0 40 11,11 40 11,22 40 11,33 40 7,33 47 4,37 47 3,37 50 1,38 50 1,39 50 1",
            "0 0 41,0 41 10,10 41 10,20 41 10,30 41 5,30 46 5,35 41 6,35 47 4,39 47 2,39 49 2",
            "0 0 21,21 0 21,0 21 30,30 21 12,30 33 12,30 45 6,36 45 6",
            "0 0 24,24 0 19,24 19 3,24 22 2,26 22 1,26 23 1,0 24 27,27 19 16,27 35 16",
            "0 0 11,11 0 11,0 11 20,0 31 20,22 0 11,33 0 11,20 11 24,20 35 16,36 35 8,36 43 8",
            "0 0 24,24 0 21,24 21 3,0 24 27,27 21 18,27 39 12,39 39 6,39 45 6",
            "0 0 23,23 0 23,0 23 28,28 23 18,28 41 10,38 41 8,38 49 2,40 49 2,42 49 2,44 49 2",
            "0 0 29,0 29 22,22 29 7,29 0 18,29 18 18,22 36 15,37 36 10,37 46 5,42 46 5",
            "0 0 30,0 30 21,21 30 9,30 0 18,30 18 18,30 36 3,21 39 12,33 36 15",
            "0 0 34,0 34 17,17 34 17,34 0 15,34 15 15,34 30 15,34 45 6,40 45 6,46 45 3,46 48 3",
            "0 0 28,0 28 23,23 28 5,28 0 22,28 22 11,39 22 11,23 33 18,41 33 9,41 42 9",
            "0 0 51"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 1,1 51 1,2 51 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 2,2 50 2,4 50 1,4 51 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 4,4 48 2,4 50 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 3,3 49 3,6 49 1,6 50 1,6 51 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 4,4 48 4",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 7,7 45 2,7 47 2,7 49 2,7 51 1,8 51 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 6,0 46 6,6 40 4,6 44 4,6 48 4",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 8,8 44 3,8 47 3,8 50 2,10 50 1,10 51 1",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 4,4 48 4,8 48 4",
            "0 0 13,0 13 13,0 26 13,0 39 13",
            "0 0 14,0 14 14,0 28 14,0 42 10,10 42 4,10 46 4,10 50 2,12 50 2",
            "0 0 15,0 15 15,0 30 10,10 30 5,10 35 5,0 40 12,12 40 3,12 43 3,12 46 3,12 49 3",
            "0 0 16,0 16 16,0 32 16,0 48 4,4 48 4,8 48 4,12 48 4",
            "0 0 17,0 17 17,0 34 9,0 43 9,9 34 8,9 42 8,9 50 2,11 50 2,13 50 2,15 50 2",
            "0 0 18,0 18 18,0 36 8,0 44 8,8 36 10,8 46 6,14 46 4,14 50 2,16 50 2",
            "0 0 19,0 19 19,0 38 7,0 45 7,7 38 6,13 38 6,7 44 8,15 44 4,15 48 4",
            "0 0 20,0 20 20,0 40 12,12 40 8,12 48 4,16 48 4",
            "0 0 21,0 21 21,0 42 10,10 42 5,10 47 5,15 42 6,15 48 4,19 48 2,19 50 2",
            "0 0 22,0 22 22,0 44 8,8 44 8,16 44 6,16 50 2,18 50 2,20 50 2",
            "0 0 23,0 23 23,0 46 6,6 46 6,12 46 6,18 46 3,18 49 3,21 46 2,21 48 2,21 50 2",
            "0 0 24,0 24 12,12 24 12,0 36 16,16 36 8,16 44 8",
            "0 0 13,0 13 13,0 26 13,0 39 13,13 0 12,13 12 12,13 24 12,13 36 12,13 48 4,17 48 4,21 48 4",
            "0 0 26,0 26 26",
            "0 0 27,0 27 14,0 41 11,11 41 3,11 44 3,14 27 13,14 40 7,11 47 5,16 47 5,21 40 6,21 46 6",
            "0 0 28,0 28 12,0 40 12,12 28 16,12 44 8,20 44 8",
            "0 0 29,0 29 23,23 29 6,23 35 6,23 41 6,23 47 3,23 50 2,26 47 3,25 50 2,27 50 2",
            "0 0 30,0 30 22,22 30 8,22 38 8,22 46 6,28 46 2,28 48 2,28 50 2",
            "0 0 31,0 31 21,21 31 10,21 41 5,26 41 5,21 46 6,27 46 4,27 50 2,29 50 2",
            "0 0 32,0 32 20,20 32 12,20 44 8,28 44 4,28 48 4",
            "0 0 33,0 33 19,19 33 7,19 40 6,19 46 6,26 33 7,25 40 8,25 48 4,29 48 4",
            "0 0 34,0 34 18,18 34 8,26 34 8,18 42 10,28 42 6,28 48 4,32 48 2,32 50 2",
            "0 0 35,0 35 17,17 35 9,17 44 8,26 35 9,25 44 8,33 44 2,33 46 2,33 48 2,33 50 2",
            "0 0 36,0 36 16,16 36 16,32 36 4,32 40 4,32 44 4,32 48 4",
            "0 0 18,0 18 18,0 36 16,16 36 2,18 0 19,18 19 19,16 38 14,30 38 7,30 45 7",
            "0 0 38,0 38 14,14 38 14,28 38 10,28 48 4,32 48 4,36 48 2,36 50 2",
            "0 0 39,0 39 13,13 39 13,26 39 13",
            "0 0 40,0 40 12,12 40 12,24 40 12,36 40 4,36 44 4,36 48 4",
            "0 0 27,0 27 25,25 27 1,26 27 1,27 0 14,27 14 14,25 28 16,25 44 8,33 44 8",
            "0 0 28,0 28 24,28 0 14,28 14 14,24 28 18,24 46 6,30 46 6,36 46 6",
            "0 0 19,19 0 12,19 12 7,31 0 12,26 12 7,0 19 33,33 12 10,33 22 10,33 32 10,33 42 10",
            "0 0 24,24 0 20,24 20 4,0 24 28,28 20 16,28 36 16",
            "0 0 13,0 13 13,0 26 13,0 39 13,13 0 32,13 32 20,33 32 12,33 44 8,41 44 4,41 48 4",
            "0 0 26,0 26 26,26 0 20,26 20 20,26 40 12,38 40 8,38 48 4,42 48 4",
            "0 0 25,25 0 22,25 22 2,25 24 1,26 24 1,0 25 27,27 22 20,27 42 10,37 42 10",
            "0 0 16,16 0 16,32 0 16,0 16 36,36 16 12,36 28 12,36 40 12",
            "0 0 13,0 13 13,0 26 13,0 39 13,13 0 36,13 36 16,29 36 16,45 36 4,45 40 4,45 44 4,45 48 4",
            "0 0 26,0 26 26,26 0 24,26 24 12,38 24 12,26 36 16,42 36 8,42 44 8",
            "0 0 34,0 34 18,34 0 17,34 17 17,18 34 18,36 34 9,36 43 9,45 34 6,45 40 6,45 46 6",
            "0 0 52"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 1,1 52 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 2,2 51 1,2 52 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 1,1 52 1,2 52 1,3 52 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 3,3 50 2,3 52 1,4 52 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 3,0 51 2,3 48 3,2 51 2,4 51 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 4,4 49 3,4 52 1,5 52 1,6 52 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 5,5 48 3,5 51 2,7 51 1,7 52 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 4,0 49 4,4 45 5,4 50 3,7 50 2,7 52 1,8 52 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 3,3 50 3,6 50 3,9 50 1,9 51 1,9 52 1",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 9,9 44 2,9 46 2,9 48 2,9 50 2,9 52 1,10 52 1",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 5,5 48 5,10 48 2,10 50 2,10 52 1,11 52 1",
            "0 0 13,0 13 13,0 26 13,0 39 7,0 46 7,7 39 6,7 45 6,7 51 2,9 51 2,11 51 2",
            "0 0 14,0 14 14,0 28 14,0 42 11,11 42 3,11 45 3,11 48 3,11 51 2,13 51 1,13 52 1",
            "0 0 15,0 15 15,0 30 9,0 39 9,0 48 5,9 30 6,9 36 6,9 42 6,5 48 5,10 48 5",
            "0 0 16,0 16 16,0 32 16,0 48 5,5 48 5,10 48 3,10 51 2,13 48 3,12 51 2,14 51 2",
            "0 0 17,0 17 17,0 34 12,0 46 7,12 34 5,12 39 5,12 44 2,7 46 7,14 44 3,14 47 3,14 50 3",
            "0 0 18,0 18 18,0 36 9,0 45 8,9 36 9,8 45 8,16 45 2,16 47 2,16 49 2,16 51 2",
            "0 0 19,0 19 19,0 38 10,0 48 5,5 48 5,10 38 9,10 47 6,16 47 3,16 50 3",
            "0 0 20,0 20 20,0 40 13,13 40 7,13 47 3,13 50 3,16 47 4,16 51 2,18 51 2",
            "0 0 21,0 21 21,0 42 11,11 42 5,16 42 5,11 47 6,17 47 4,17 51 2,19 51 2",
            "0 0 22,0 22 11,0 33 10,0 43 10,11 22 11,10 33 12,10 45 8,18 45 4,18 49 4",
            "0 0 23,0 23 23,0 46 7,7 46 7,14 46 7,21 46 2,21 48 2,21 50 2,21 52 1,22 52 1",
            "0 0 24,0 24 12,12 24 12,0 36 17,17 36 7,17 43 7,17 50 3,20 50 3,23 50 1,23 51 1,23 52 1",
            "0 0 25,0 25 14,0 39 14,14 25 11,14 36 11,14 47 6,20 47 3,20 50 3,23 47 2,23 49 2,23 51 2",
            "0 0 26,0 26 13,13 26 13,0 39 14,14 39 6,20 39 6,14 45 8,22 45 4,22 49 4",
            "0 0 27,0 27 13,0 40 13,13 27 14,13 41 6,13 47 6,19 41 8,19 49 4,23 49 4",
            "0 0 28,0 28 13,0 41 12,12 41 1,12 42 1,13 28 15,12 43 10,22 43 6,22 49 4,26 49 2,26 51 2",
            "0 0 29,0 29 24,24 29 5,24 34 5,24 39 5,24 44 5,24 49 4,28 49 1,28 50 1,28 51 1,28 52 1",
            "0 0 15,15 0 15,0 15 20,0 35 18,20 15 10,20 25 10,18 35 12,18 47 6,24 47 6",
            "0 0 31,0 31 11,0 42 11,11 31 10,21 31 10,11 41 12,23 41 8,23 49 4,27 49 4",
            "0 0 32,0 32 21,21 32 11,21 43 5,21 48 5,26 43 6,26 49 4,30 49 2,30 51 2",
            "0 0 33,0 33 20,20 33 13,20 46 7,27 46 3,30 46 3,27 49 4,31 49 2,31 51 2",
            "0 0 34,0 34 19,19 34 10,19 44 9,29 34 5,29 39 5,28 44 6,28 50 3,31 50 3",
            "0 0 35,0 35 18,18 35 9,18 44 9,27 35 8,27 43 8,27 51 2,29 51 2,31 51 2,33 51 2",
            "0 0 27,0 27 26,27 0 9,27 9 9,27 18 9,26 27 10,26 37 10,26 47 6,32 47 4,32 51 2,34 51 2",
            "0 0 37,0 37 16,16 37 16,32 37 5,32 42 5,32 47 3,32 50 3,35 47 2,35 49 2,35 51 2",
            "0 0 38,0 38 15,15 38 9,15 47 6,24 38 9,21 47 6,27 47 6,33 38 5,33 43 5,33 48 5",
            "0 0 19,0 19 17,0 36 17,17 19 1,18 19 1,19 0 20,17 20 22,17 42 11,28 42 11",
            "0 0 40,0 40 13,13 40 13,26 40 7,26 47 6,33 40 7,32 47 6,38 47 2,38 49 2,38 51 2",
            "0 0 27,0 27 26,26 27 1,27 0 14,27 14 14,26 28 15,26 43 10,36 43 5,36 48 5",
            "0 0 21,21 0 21,0 21 32,32 21 10,32 31 10,32 41 6,32 47 6,38 41 4,38 45 4,38 49 4",
            "0 0 43,0 43 10,10 43 10,20 43 10,30 43 10,40 43 3,40 46 3,40 49 3,40 52 1,41 52 1,42 52 1",
            "0 0 33,0 33 20,20 33 12,20 45 8,33 0 11,33 11 11,33 22 11,32 33 12,28 45 8,36 45 8",
            "0 0 24,24 0 21,24 21 3,27 21 2,27 23 1,28 23 1,0 24 29,29 21 16,29 37 16",
            "0 0 23,0 23 18,0 41 12,23 0 23,18 23 18,12 41 12,24 41 12,36 23 10,36 33 10,36 43 10",
            "0 0 34,0 34 19,34 0 13,34 13 13,34 26 4,34 30 4,19 34 19,38 26 9,38 35 9,38 44 9",
            "0 0 25,25 0 23,25 23 2,27 23 1,27 24 1,0 25 28,28 23 20,28 43 10,38 43 10",
            "0 0 17,0 17 17,17 0 32,17 32 2,0 34 19,19 32 21,40 32 9,40 41 9,40 50 3,43 50 3,46 50 3",
            "0 0 31,0 31 22,22 31 9,31 0 19,31 19 19,31 38 2,33 38 2,22 40 13,35 38 15",
            "0 0 26,26 0 25,26 25 1,0 26 27,27 25 12,39 25 12,27 37 16,43 37 8,43 45 8",
            "0 0 38,0 38 15,15 38 15,30 38 4,34 38 4,38 0 14,38 14 14,38 28 14,30 42 11,41 42 11",
            "0 0 53"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1,0 53 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 2,2 52 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 4,4 50 1,4 51 1,4 52 1,4 53 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 6",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 5,5 49 2,5 51 2,5 53 1,6 53 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 6,6 48 2,6 50 2,6 52 2",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 9",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 4,4 50 4,8 50 2,8 52 2",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 5,0 49 5,5 44 6,5 50 4,9 50 2,9 52 2",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 6,6 48 6",
            "0 0 13,0 13 13,0 26 13,0 39 10,0 49 5,5 49 5,10 39 3,10 42 3,10 45 3,10 48 3,10 51 3",
            "0 0 14,0 14 14,0 28 14,0 42 6,0 48 6,6 42 8,6 50 4,10 50 4",
            "0 0 15,0 15 15,0 30 15,0 45 9,9 45 6,9 51 3,12 51 3",
            "0 0 16,0 16 16,0 32 16,0 48 6,6 48 6,12 48 4,12 52 2,14 52 2",
            "0 0 17,0 17 17,0 34 9,9 34 8,9 42 1,10 42 1,0 43 11,11 42 6,11 48 6",
            "0 0 18,0 18 18,0 36 18",
            "0 0 19,0 19 19,0 38 9,0 47 7,7 47 1,8 47 1,9 38 10,7 48 6,13 48 6",
            "0 0 20,0 20 20,0 40 14,14 40 6,14 46 6,14 52 2,16 52 2,18 52 2",
            "0 0 21,0 21 21,0 42 12,12 42 9,12 51 3,15 51 3,18 51 3",
            "0 0 22,0 22 22,0 44 10,10 44 6,10 50 4,16 44 6,14 50 4,18 50 4",
            "0 0 23,0 23 11,0 34 11,0 45 9,9 45 2,11 23 12,11 35 12,9 47 7,16 47 7",
            "0 0 24,0 24 24,0 48 6,6 48 6,12 48 6,18 48 6",
            "0 0 25,0 25 14,14 25 11,14 36 3,0 39 15,15 39 2,15 41 2,15 43 1,16 43 1,17 36 8,15 44 10",
            "0 0 26,0 26 14,0 40 14,14 26 12,14 38 12,14 50 4,18 50 4,22 50 4",
            "0 0 27,0 27 27",
            "0 0 28,0 28 14,0 42 12,14 28 14,12 42 12,24 42 4,24 46 4,24 50 4",
            "0 0 16,0 16 16,16 0 13,16 13 13,16 26 6,0 32 22,22 26 7,22 33 7,22 40 7,22 47 7",
            "0 0 30,0 30 24,24 30 6,24 36 6,24 42 6,24 48 6",
            "0 0 31,0 31 11,11 31 11,0 42 12,22 31 9,22 40 2,12 42 12,24 40 7,24 47 7",
            "0 0 32,0 32 22,22 32 10,22 42 6,22 48 6,28 42 4,28 46 4,28 50 4",
            "0 0 33,0 33 21,21 33 12,21 45 9,30 45 3,30 48 3,30 51 3",
            "0 0 34,0 34 20,20 34 14,20 48 6,26 48 6,32 48 2,32 50 2,32 52 2",
            "0 0 35,0 35 19,19 35 9,28 35 7,28 42 1,28 43 1,19 44 10,29 42 6,29 48 6",
            "0 0 36,0 36 18,18 36 18",
            "0 0 37,0 37 17,17 37 9,17 46 8,25 46 1,25 47 1,26 37 11,25 48 6,31 48 6",
            "0 0 38,0 38 16,16 38 16,32 38 6,32 44 6,32 50 4,36 50 2,36 52 2",
            "0 0 39,0 39 15,15 39 15,30 39 9,30 48 6,36 48 3,36 51 3",
            "0 0 40,0 40 14,14 40 14,28 40 6,34 40 6,28 46 8,36 46 4,36 50 4",
            "0 0 25,25 0 16,25 16 9,0 25 29,29 25 5,34 16 7,34 23 7,29 30 12,29 42 12",
            "0 0 42,0 42 12,12 42 12,24 42 12,36 42 6,36 48 6",
            "0 0 24,24 0 19,24 19 5,29 19 5,0 24 30,30 24 4,34 19 9,30 28 13,30 41 13",
            "0 0 22,22 0 22,0 22 32,32 22 12,32 34 12,32 46 8,40 46 4,40 50 4",
            "0 0 27,0 27 27,27 0 18,27 18 18,27 36 18",
            "0 0 32,0 32 22,22 32 10,32 0 14,32 14 14,32 28 14,22 42 12,34 42 12",
            "0 0 27,0 27 27,27 0 20,27 20 20,27 40 14,41 40 6,41 46 6,41 52 2,43 52 2,45 52 2",
            "0 0 24,24 0 24,0 24 30,30 24 18,30 42 12,42 42 6,42 48 6",
            "0 0 29,0 29 25,29 0 20,29 20 9,25 29 13,25 42 12,38 20 11,38 31 11,37 42 12",
            "0 0 28,0 28 26,28 0 22,28 22 6,34 22 6,26 28 14,26 42 12,40 22 10,40 32 10,38 42 12",
            "0 0 27,0 27 27,27 0 24,27 24 24,27 48 6,33 48 6,39 48 6,45 48 6",
            "0 0 26,26 0 26,0 26 28,28 26 12,40 26 12,28 38 16,44 38 8,44 46 8",
            "0 0 27,0 27 27,27 0 26,27 26 14,27 40 14,41 26 12,41 38 12,41 50 4,45 50 4,49 50 4",
            "0 0 54"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1,0 53 1,0 54 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 2,0 54 1,1 54 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 3,0 54 1,1 54 1,2 54 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 3,3 52 1,3 53 1,3 54 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 5",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 3,3 48 3,0 51 4,4 51 2,4 53 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 3,0 52 3,3 49 4,3 53 2,5 53 2",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 4,0 52 3,4 48 4,3 52 3,6 52 2,6 54 1,7 54 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 5,0 50 5,5 45 4,5 49 4,5 53 2,7 53 2",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 5,5 50 5",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 11",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 7,7 48 5,7 53 2,9 53 2,11 53 1,11 54 1",
            "0 0 13,0 13 13,0 26 13,0 39 13,0 52 3,3 52 3,6 52 3,9 52 3,12 52 1,12 53 1,12 54 1",
            "0 0 14,0 14 14,0 28 14,0 42 7,0 49 6,7 42 7,6 49 6,12 49 2,12 51 2,12 53 2",
            "0 0 15,0 15 15,0 30 15,0 45 10,10 45 5,10 50 5",
            "0 0 16,0 16 16,0 32 16,0 48 7,7 48 7,14 48 2,14 50 2,14 52 2,14 54 1,15 54 1",
            "0 0 17,0 17 17,0 34 17,0 51 4,4 51 4,8 51 4,12 51 4,16 51 1,16 52 1,16 53 1,16 54 1",
            "0 0 18,0 18 18,0 36 11,0 47 8,8 47 3,11 36 7,11 43 7,8 50 5,13 50 5",
            "0 0 19,0 19 19,0 38 12,0 50 5,5 50 5,10 50 2,12 38 7,12 45 7,10 52 3,13 52 3,16 52 3",
            "0 0 20,0 20 20,0 40 15,15 40 5,15 45 5,15 50 5",
            "0 0 21,0 21 21,0 42 13,13 42 8,13 50 5,18 50 3,18 53 2,20 53 1,20 54 1",
            "0 0 22,0 22 22,0 44 11,11 44 11",
            "0 0 23,0 23 23,0 46 9,9 46 9,18 46 5,18 51 4,22 51 1,22 52 1,22 53 1,22 54 1",
            "0 0 24,0 24 16,0 40 15,16 24 8,16 32 8,15 40 9,15 49 6,21 49 3,21 52 3",
            "0 0 25,0 25 15,0 40 15,15 25 10,15 35 10,15 45 10",
            "0 0 26,0 26 13,13 26 13,0 39 16,16 39 10,16 49 6,22 49 4,22 53 2,24 53 2",
            "0 0 27,0 27 17,0 44 11,11 44 3,14 44 3,17 27 10,17 37 10,11 47 8,19 47 8",
            "0 0 28,0 28 17,0 45 10,17 28 11,17 39 3,17 42 3,10 45 10,20 39 8,20 47 8",
            "0 0 29,0 29 13,0 42 13,13 29 16,13 45 10,23 45 6,23 51 4,27 51 2,27 53 2",
            "0 0 30,0 30 15,0 45 10,15 30 15,10 45 10,20 45 10",
            "0 0 31,0 31 16,0 47 8,8 47 8,16 31 15,16 46 9,25 46 6,25 52 3,28 52 3",
            "0 0 32,0 32 23,23 32 9,23 41 9,23 50 5,28 50 4,28 54 1,29 54 1,30 54 1,31 54 1",
            "0 0 33,0 33 22,22 33 11,22 44 11",
            "0 0 34,0 34 21,21 34 13,21 47 8,29 47 5,29 52 3,32 52 2,32 54 1,33 54 1",
            "0 0 35,0 35 20,20 35 15,20 50 5,25 50 5,30 50 5",
            "0 0 27,27 0 9,27 9 9,27 18 9,0 27 28,28 27 8,28 35 8,28 43 8,28 51 4,32 51 4",
            "0 0 37,0 37 18,18 37 11,18 48 7,29 37 8,29 45 3,25 48 7,32 45 5,32 50 5",
            "0 0 19,19 0 19,0 19 22,0 41 14,22 19 16,22 35 6,14 41 14,28 35 10,28 45 10",
            "0 0 19,0 19 18,0 37 18,18 19 1,19 0 20,18 20 21,18 41 14,32 41 7,32 48 7",
            "0 0 40,0 40 15,15 40 15,30 40 10,30 50 5,35 50 5",
            "0 0 16,0 16 16,16 0 25,16 25 7,0 32 23,23 25 18,23 43 12,35 43 6,35 49 6",
            "0 0 28,0 28 27,28 0 14,28 14 14,27 28 15,27 43 12,39 43 3,39 46 3,39 49 3,39 52 3",
            "0 0 25,25 0 18,25 18 7,0 25 30,30 25 2,30 27 2,32 18 11,30 29 13,30 42 13",
            "0 0 44,0 44 11,11 44 11,22 44 11,33 44 11",
            "0 0 45,0 45 10,10 45 10,20 45 10,30 45 10,40 45 5,40 50 5",
            "0 0 19,0 19 19,0 38 17,17 38 2,19 0 27,19 27 13,17 40 15,32 27 14,32 41 14",
            "0 0 32,0 32 23,32 0 15,32 15 15,32 30 2,23 32 11,34 30 13,23 43 12,35 43 12",
            "0 0 26,26 0 22,26 22 4,0 26 29,30 22 4,29 26 5,29 31 5,34 22 14,29 36 19",
            "0 0 26,26 0 23,26 23 3,0 26 29,29 23 20,29 43 12,41 43 8,41 51 4,45 51 4",
            "0 0 25,25 0 25,0 25 30,30 25 20,30 45 10,40 45 10",
            "0 0 34,0 34 21,34 0 17,34 17 17,21 34 21,42 34 9,42 43 9,42 52 3,45 52 3,48 52 3",
            "0 0 27,27 0 25,27 25 1,27 26 1,0 27 28,28 25 24,28 49 6,34 49 6,40 49 6,46 49 6",
            "0 0 33,0 33 22,22 33 11,22 44 11,33 0 20,33 20 20,33 40 15,48 40 5,48 45 5,48 50 5",
            "0 0 27,27 0 27,0 27 28,28 27 14,28 41 14,42 27 12,42 39 12,42 51 4,46 51 4,50 51 4",
            "0 0 55"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1,0 53 1,0 54 1,0 55 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 2,0 54 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 3,0 54 2,2 54 1,2 55 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 3,0 53 3,3 50 2,3 52 2,3 54 2",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 6,0 54 2,2 54 2,4 54 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 7",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 8",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 9,0 54 2,2 54 2,4 54 2,6 54 2,8 54 1,8 55 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 6,6 50 4,6 54 2,8 54 2",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 8,0 52 4,4 52 4,8 44 3,8 47 3,8 50 3,8 53 3",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 8,8 48 4,8 52 4",
            "0 0 13,0 13 13,0 26 13,0 39 13,0 52 4,4 52 4,8 52 4,12 52 1,12 53 1,12 54 1,12 55 1",
            "0 0 14,0 14 14,0 28 14,0 42 14",
            "0 0 15,0 15 15,0 30 15,0 45 11,11 45 4,11 49 4,11 53 3,14 53 1,14 54 1,14 55 1",
            "0 0 16,0 16 16,0 32 16,0 48 8,8 48 8",
            "0 0 17,0 17 17,0 34 17,0 51 5,5 51 5,10 51 5,15 51 2,15 53 2,15 55 1,16 55 1",
            "0 0 18,0 18 18,0 36 10,0 46 10,10 36 8,10 44 8,10 52 4,14 52 4",
            "0 0 19,0 19 19,0 38 11,0 49 7,11 38 8,11 46 3,7 49 7,14 46 5,14 51 5",
            "0 0 20,0 20 20,0 40 16,16 40 4,16 44 4,16 48 4,16 52 4",
            "0 0 21,0 21 21,0 42 14,14 42 7,14 49 7",
            "0 0 22,0 22 22,0 44 12,12 44 6,12 50 6,18 44 4,18 48 4,18 52 4",
            "0 0 23,0 23 23,0 46 10,10 46 10,20 46 3,20 49 3,20 52 3,20 55 1,21 55 1,22 55 1",
            "0 0 24,0 24 24,0 48 8,8 48 8,16 48 8",
            "0 0 25,0 25 14,14 25 11,14 36 3,0 39 17,17 36 8,17 44 8,17 52 4,21 52 4",
            "0 0 26,0 26 20,0 46 10,10 46 10,20 26 6,20 32 6,20 38 6,20 44 6,20 50 6",
            "0 0 27,0 27 14,14 27 13,14 40 1,0 41 15,15 40 12,15 52 4,19 52 4,23 52 4",
            "0 0 28,0 28 28",
            "0 0 29,0 29 14,0 43 13,13 43 1,14 29 15,13 44 12,25 44 4,25 48 4,25 52 4",
            "0 0 18,0 18 18,18 0 12,18 12 12,18 24 12,0 36 20,20 36 10,20 46 10",
            "0 0 31,0 31 14,0 45 11,11 45 3,14 31 17,11 48 8,19 48 8,27 48 4,27 52 4",
            "0 0 32,0 32 24,24 32 8,24 40 8,24 48 8",
            "0 0 33,0 33 23,23 33 10,23 43 10,23 53 3,26 53 3,29 53 3,32 53 1,32 54 1,32 55 1",
            "0 0 34,0 34 22,22 34 12,22 46 6,22 52 4,28 46 6,26 52 4,30 52 4",
            "0 0 35,0 35 21,21 35 14,21 49 7,28 49 7",
            "0 0 36,0 36 20,20 36 16,20 52 4,24 52 4,28 52 4,32 52 4",
            "0 0 37,0 37 19,19 37 11,19 48 8,27 48 3,30 37 7,30 44 7,27 51 5,32 51 5",
            "0 0 38,0 38 18,18 38 10,18 48 8,28 38 10,26 48 8,34 48 4,34 52 4",
            "0 0 39,0 39 17,17 39 17,34 39 5,34 44 5,34 49 5,34 54 2,36 54 2,38 54 1,38 55 1",
            "0 0 40,0 40 16,16 40 16,32 40 8,32 48 8",
            "0 0 41,0 41 15,15 41 15,30 41 11,30 52 4,34 52 4,38 52 3,38 55 1,39 55 1,40 55 1",
            "0 0 42,0 42 14,14 42 14,28 42 14",
            "0 0 43,0 43 13,13 43 13,26 43 13,39 43 4,39 47 4,39 51 4,39 55 1,40 55 1,41 55 1,42 55 1",
            "0 0 44,0 44 12,12 44 12,24 44 12,36 44 8,36 52 4,40 52 4",
            "0 0 24,0 24 24,0 48 8,8 48 8,16 48 8,24 0 21,24 21 21,24 42 14,38 42 7,38 49 7",
            "0 0 46,0 46 10,10 46 10,20 46 10,30 46 10,40 46 6,40 52 4,44 52 2,44 54 2",
            "0 0 20,0 20 20,0 40 16,20 0 27,20 27 13,16 40 16,32 40 1,33 27 14,32 41 15",
            "0 0 24,24 0 24,0 24 32,32 24 16,32 40 16",
            "0 0 28,0 28 28,28 0 21,28 21 21,28 42 14,42 42 7,42 49 7",
            "0 0 28,0 28 28,28 0 22,28 22 22,28 44 12,40 44 6,40 50 6,46 44 4,46 48 4,46 52 4",
            "0 0 16,0 16 16,0 32 16,0 48 8,8 48 8,16 0 35,16 35 21,37 35 14,37 49 7,44 49 7",
            "0 0 28,0 28 28,28 0 24,28 24 24,28 48 8,36 48 8,44 48 8",
            "0 0 29,0 29 27,29 0 24,29 24 5,27 29 7,27 36 7,34 24 19,27 43 13,40 43 13",
            "0 0 34,0 34 22,22 34 6,28 34 6,34 0 20,34 20 20,22 40 16,38 40 16",
            "0 0 23,0 23 14,14 23 9,14 32 5,0 37 19,23 0 32,19 32 24,43 32 12,43 44 12",
            "0 0 56"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1,0 53 1,0 54 1,0 55 1,0 56 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 2,0 54 2,0 56 1,1 56 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 3,0 54 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 4,0 56 1,1 56 1,2 56 1,3 56 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 5,0 55 2,2 55 2,4 55 1,4 56 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 6,0 54 3,3 54 3",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 4,0 53 4,4 49 3,4 52 3,4 55 2,6 55 1,6 56 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 4,4 48 4,0 52 5,5 52 3,5 55 2,7 55 1,7 56 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 9,0 54 3,3 54 3,6 54 3",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 7,7 50 3,7 53 3,7 56 1,8 56 1,9 56 1",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 6,6 44 5,6 49 1,0 50 7,7 49 4,7 53 4",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 9,9 48 3,9 51 3,9 54 3",
            "0 0 13,0 13 13,0 26 13,0 39 13,0 52 5,5 52 5,10 52 3,10 55 2,12 55 1,12 56 1",
            "0 0 14,0 14 14,0 28 14,0 42 7,7 42 7,0 49 8,8 49 6,8 55 2,10 55 2,12 55 2",
            "0 0 15,0 15 15,0 30 15,0 45 12,12 45 3,12 48 3,12 51 3,12 54 3",
            "0 0 16,0 16 16,0 32 16,0 48 9,9 48 7,9 55 2,11 55 2,13 55 2,15 55 1,15 56 1",
            "0 0 17,0 17 17,0 34 17,0 51 6,6 51 6,12 51 3,12 54 3,15 51 2,15 53 2,15 55 2",
            "0 0 18,0 18 18,0 36 9,9 36 9,0 45 12,12 45 6,12 51 6",
            "0 0 19,0 19 19,0 38 19",
            "0 0 20,0 20 20,0 40 9,0 49 8,8 49 1,8 50 1,9 40 11,8 51 6,14 51 6",
            "0 0 21,0 21 21,0 42 15,15 42 6,15 48 6,15 54 3,18 54 3",
            "0 0 22,0 22 22,0 44 13,13 44 9,13 53 4,17 53 4,21 53 1,21 54 1,21 55 1,21 56 1",
            "0 0 23,0 23 23,0 46 11,11 46 8,11 54 3,14 54 3,19 46 4,19 50 4,17 54 3,20 54 3",
            "0 0 24,0 24 24,0 48 9,9 48 9,18 48 6,18 54 3,21 54 3",
            "0 0 25,0 25 25,0 50 7,7 50 7,14 50 7,21 50 4,21 54 3,24 54 1,24 55 1,24 56 1",
            "0 0 26,0 26 11,0 37 11,0 48 9,11 26 15,11 41 7,9 48 9,18 41 8,18 49 8",
            "0 0 27,0 27 15,0 42 15,15 27 12,15 39 12,15 51 6,21 51 6",
            "0 0 28,0 28 21,0 49 8,8 49 8,21 28 7,21 35 7,21 42 7,16 49 8,24 49 4,24 53 4",
            "0 0 29,0 29 21,0 50 7,7 50 7,14 50 7,21 29 8,21 37 8,21 45 8,21 53 4,25 53 4",
            "0 0 30,0 30 15,0 45 12,15 30 15,12 45 12,24 45 6,24 51 6",
            "0 0 31,0 31 11,11 31 11,0 42 15,15 42 7,22 31 9,22 40 9,15 49 8,23 49 8",
            "0 0 32,0 32 25,25 32 7,25 39 7,25 46 7,25 53 4,29 53 3,29 56 1,30 56 1,31 56 1",
            "0 0 33,0 33 24,24 33 9,24 42 9,24 51 6,30 51 3,30 54 3",
            "0 0 17,17 0 17,0 17 18,18 17 16,18 33 2,20 33 2,0 35 22,22 33 12,22 45 12",
            "0 0 35,0 35 22,22 35 13,22 48 9,31 48 4,31 52 4,31 56 1,32 56 1,33 56 1,34 56 1",
            "0 0 36,0 36 21,21 36 15,21 51 6,27 51 6,33 51 3,33 54 3",
            "0 0 37,0 37 20,20 37 9,29 37 8,29 45 1,30 45 1,20 46 11,31 45 6,31 51 6",
            "0 0 38,0 38 19,19 38 19",
            "0 0 39,0 39 18,18 39 9,18 48 9,27 39 12,27 51 6,33 51 6",
            "0 0 40,0 40 17,17 40 17,34 40 6,34 46 6,34 52 3,34 55 2,37 52 3,36 55 2,38 55 2",
            "0 0 41,0 41 16,16 41 16,32 41 9,32 50 7,39 50 2,39 52 2,39 54 2,39 56 1,40 56 1",
            "0 0 21,0 21 18,0 39 18,21 0 21,18 21 24,18 45 12,30 45 12",
            "0 0 43,0 43 14,14 43 14,28 43 7,28 50 7,35 43 8,35 51 6,41 51 2,41 53 2,41 55 2",
            "0 0 27,27 0 17,27 17 5,27 22 5,0 27 30,30 27 2,32 17 12,30 29 14,30 43 14",
            "0 0 30,0 30 27,30 0 15,30 15 15,27 30 18,27 48 9,36 48 9",
            "0 0 26,26 0 20,26 20 6,0 26 31,31 26 1,32 20 7,39 20 7,31 27 15,31 42 15",
            "0 0 26,26 0 21,26 21 5,0 26 31,31 21 16,31 37 16,31 53 4,35 53 4,39 53 4,43 53 4",
            "0 0 27,27 0 21,27 21 3,27 24 3,0 27 30,30 21 18,30 39 18",
            "0 0 19,0 19 19,0 38 19,19 0 30,19 30 15,19 45 12,34 30 15,31 45 12,43 45 6,43 51 6",
            "0 0 25,25 0 25,0 25 32,32 25 18,32 43 14,46 43 4,46 47 4,46 51 4,46 55 2,48 55 2",
            "0 0 36,0 36 21,36 0 15,36 15 15,36 30 6,21 36 21,42 30 9,42 39 9,42 48 9",
            "0 0 28,28 0 24,28 24 4,0 28 29,29 28 3,29 31 3,32 24 10,42 24 10,29 34 23",
            "0 0 28,28 0 25,28 25 1,28 26 1,28 27 1,0 28 29,29 25 24,29 49 8,37 49 8,45 49 8",
            "0 0 33,0 33 24,24 33 9,33 0 21,33 21 21,24 42 15,39 42 15",
            "0 0 19,0 19 19,0 38 19,19 0 36,19 36 21,40 36 15,40 51 6,46 51 6,52 51 3,52 54 3",
            "0 0 34,0 34 23,34 0 22,34 22 12,23 34 23,46 22 10,46 32 10,46 42 10,46 52 5,51 52 5",
            "0 0 57"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1,0 53 1,0 54 1,0 55 1,0 56 1,0 57 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 2,0 54 2,0 56 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 3,0 54 3,0 57 1,1 57 1,2 57 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 4,0 56 2,2 56 2",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 5,0 55 3,3 55 2,3 57 1,4 57 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 6,0 54 4,4 54 2,4 56 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 7,0 56 2,2 56 2,4 56 2,6 56 1,6 57 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 8,0 56 2,2 56 2,4 56 2,6 56 2",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 9,0 54 4,4 54 4,8 54 1,8 55 1,8 56 1,8 57 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 8,8 50 2,8 52 2,8 54 2,8 56 2",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 11,0 55 3,3 55 3,6 55 3,9 55 2,9 57 1,10 57 1",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 6,0 54 4,6 48 6,4 54 4,8 54 4",
            "0 0 13,0 13 13,0 26 13,0 39 13,0 52 6,6 52 3,6 55 3,9 52 4,9 56 2,11 56 2",
            "0 0 14,0 14 14,0 28 14,0 42 8,0 50 8,8 42 6,8 48 6,8 54 4,12 54 2,12 56 2",
            "0 0 15,0 15 15,0 30 9,0 39 9,9 30 6,9 36 6,9 42 6,0 48 10,10 48 5,10 53 5",
            "0 0 16,0 16 16,0 32 16,0 48 10,10 48 6,10 54 4,14 54 2,14 56 2",
            "0 0 17,0 17 17,0 34 17,0 51 7,7 51 7,14 51 3,14 54 3,14 57 1,15 57 1,16 57 1",
            "0 0 18,0 18 18,0 36 18,0 54 4,4 54 4,8 54 4,12 54 4,16 54 2,16 56 2",
            "0 0 19,0 19 19,0 38 15,0 53 5,5 53 5,10 53 5,15 38 4,15 42 4,15 46 4,15 50 4,15 54 4",
            "0 0 20,0 20 20,0 40 10,0 50 8,10 40 10,8 50 8,16 50 4,16 54 4",
            "0 0 21,0 21 21,0 42 16,16 42 5,16 47 5,16 52 3,16 55 3,19 52 2,19 54 2,19 56 2",
            "0 0 22,0 22 22,0 44 14,14 44 8,14 52 6,20 52 2,20 54 2,20 56 2",
            "0 0 23,0 23 23,0 46 12,12 46 8,12 54 4,16 54 4,20 46 3,20 49 3,20 52 3,20 55 3",
            "0 0 24,0 24 24,0 48 10,10 48 10,20 48 4,20 52 4,20 56 2,22 56 2",
            "0 0 25,0 25 25,0 50 8,8 50 8,16 50 4,16 54 4,20 50 5,20 55 3,23 55 2,23 57 1,24 57 1",
            "0 0 26,0 26 26,0 52 6,6 52 6,12 52 6,18 52 6,24 52 2,24 54 2,24 56 2",
            "0 0 27,0 27 15,15 27 12,15 39 2,15 41 1,0 42 16,17 39 2,16 41 3,16 44 3,19 39 8,16 47 11",
            "0 0 28,0 28 14,14 28 14,0 42 16,16 42 12,16 54 4,20 54 4,24 54 4",
            "0 0 29,0 29 29",
            "0 0 30,0 30 14,0 44 14,14 30 16,14 46 12,26 46 4,26 50 4,26 54 4",
            "0 0 19,0 19 19,19 0 12,19 12 12,19 24 12,19 36 1,19 37 1,0 38 20,20 36 11,20 47 11",
            "0 0 32,0 32 26,26 32 6,26 38 6,26 44 6,26 50 6,26 56 2,28 56 2,30 56 2",
            "0 0 22,22 0 11,22 11 11,0 22 24,0 46 12,12 46 12,24 22 9,24 31 9,24 40 9,24 49 9",
            "0 0 34,0 34 24,24 34 10,24 44 10,24 54 4,28 54 4,32 54 2,32 56 2",
            "0 0 35,0 35 23,23 35 12,23 47 8,23 55 3,26 55 3,31 47 4,31 51 4,29 55 3,32 55 3",
            "0 0 36,0 36 22,22 36 14,22 50 8,30 50 6,30 56 2,32 56 2,34 56 2",
            "0 0 37,0 37 21,21 37 16,21 53 5,26 53 5,31 53 3,31 56 2,34 53 3,33 56 2,35 56 2",
            "0 0 38,0 38 20,20 38 10,20 48 10,30 38 8,30 46 8,30 54 4,34 54 4",
            "0 0 39,0 39 19,19 39 15,19 54 4,23 54 4,27 54 4,34 39 5,34 44 5,34 49 5,31 54 4,35 54 4",
            "0 0 40,0 40 18,18 40 18,36 40 4,36 44 4,36 48 4,36 52 4,36 56 2,38 56 2",
            "0 0 41,0 41 17,17 41 17,34 41 7,34 48 7,34 55 3,37 55 3,40 55 1,40 56 1,40 57 1",
            "0 0 42,0 42 16,16 42 16,32 42 10,32 52 6,38 52 4,38 56 2,40 56 2",
            "0 0 43,0 43 15,15 43 9,15 52 6,24 43 9,21 52 6,27 52 6,33 43 10,33 53 5,38 53 5",
            "0 0 22,22 0 22,0 22 36,36 22 8,36 30 8,36 38 8,36 46 8,36 54 4,40 54 4",
            "0 0 45,0 45 13,13 45 13,26 45 13,39 45 6,39 51 3,42 51 3,39 54 4,43 54 2,43 56 2",
            "0 0 46,0 46 12,12 46 12,24 46 12,36 46 6,36 52 6,42 46 4,42 50 4,42 54 4",
            "0 0 47,0 47 11,11 47 11,22 47 11,33 47 11,44 47 3,44 50 3,44 53 3,44 56 2,46 56 1,46 57 1",
            "0 0 24,24 0 24,0 24 34,34 24 14,34 38 14,34 52 6,40 52 6,46 52 2,46 54 2,46 56 2",
            "0 0 29,0 29 29,29 0 20,29 20 20,29 40 10,29 50 8,39 40 10,37 50 8,45 50 4,45 54 4",
            "0 0 28,28 0 22,28 22 6,0 28 30,30 28 4,30 32 4,30 36 2,32 36 2,34 22 16,30 38 20",
            "0 0 29,0 29 29,29 0 22,29 22 22,29 44 14,43 44 8,43 52 6,49 52 2,49 54 2,49 56 2",
            "0 0 26,26 0 26,0 26 32,32 26 20,32 46 12,44 46 8,44 54 4,48 54 4",
            "0 0 29,0 29 29,29 0 24,29 24 24,29 48 10,39 48 10,49 48 4,49 52 4,49 56 2,51 56 2",
            "0 0 28,28 0 26,28 26 2,0 28 30,30 26 24,30 50 8,38 50 8,46 50 8",
            "0 0 33,0 33 25,33 0 22,33 22 11,25 33 15,25 48 10,44 22 11,40 33 15,35 48 10,45 48 10",
            "0 0 42,0 42 16,16 42 16,42 0 14,42 14 14,42 28 14,32 42 16,48 42 8,48 50 8",
            "0 0 29,0 29 29,29 0 28,29 28 14,43 28 14,29 42 16,45 42 12,45 54 4,49 54 4,53 54 4",
            "0 0 58"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1,0 53 1,0 54 1,0 55 1,0 56 1,0 57 1,0 58 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 2,0 54 2,0 56 2,0 58 1,1 58 1",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 3,0 54 3,0 57 2,2 57 1,2 58 1",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 4,0 56 3,3 56 1,3 57 1,3 58 1",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 5,0 55 4,4 55 1,4 56 1,4 57 1,4 58 1",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 6,0 54 3,0 57 2,3 54 3,2 57 2,4 57 2",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 7,0 56 3,3 56 3,6 56 1,6 57 1,6 58 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 8,0 56 3,3 56 3,6 56 2,6 58 1,7 58 1",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 9,0 54 5,5 54 4,5 58 1,6 58 1,7 58 1,8 58 1",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 5,0 55 4,5 50 5,4 55 4,8 55 2,8 57 2",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 11,0 55 4,4 55 4,8 55 3,8 58 1,9 58 1,10 58 1",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 8,0 56 3,3 56 3,8 48 4,8 52 4,6 56 3,9 56 3",
            "0 0 13,0 13 13,0 26 13,0 39 13,0 52 7,7 52 3,10 52 3,7 55 4,11 55 2,11 57 2",
            "0 0 14,0 14 14,0 28 14,0 42 7,7 42 7,0 49 10,10 49 4,10 53 4,10 57 2,12 57 2",
            "0 0 15,0 15 15,0 30 15,0 45 7,0 52 7,7 45 8,7 53 6,13 53 2,13 55 2,13 57 2",
            "0 0 16,0 16 16,0 32 16,0 48 11,11 48 5,11 53 3,11 56 3,14 53 2,14 55 2,14 57 2",
            "0 0 17,0 17 17,0 34 17,0 51 8,8 51 4,8 55 4,12 51 5,12 56 3,15 56 2,15 58 1,16 58 1",
            "0 0 18,0 18 18,0 36 18,0 54 5,5 54 5,10 54 5,15 54 3,15 57 2,17 57 1,17 58 1",
            "0 0 19,0 19 19,0 38 10,10 38 9,10 47 1,0 48 11,11 47 8,11 55 4,15 55 4",
            "0 0 20,0 20 12,0 32 12,12 20 8,12 28 8,12 36 8,0 44 15,15 44 5,15 49 5,15 54 5",
            "0 0 21,0 21 21,0 42 17,17 42 4,17 46 4,17 50 4,17 54 4,17 58 1,18 58 1,19 58 1,20 58 1",
            "0 0 22,0 22 11,11 22 11,0 33 12,12 33 10,12 43 2,0 45 14,14 43 8,14 51 8",
            "0 0 23,0 23 23,0 46 13,13 46 10,13 56 3,16 56 3,19 56 3,22 56 1,22 57 1,22 58 1",
            "0 0 24,0 24 24,0 48 11,11 48 6,11 54 5,16 54 1,17 48 7,16 55 4,20 55 4",
            "0 0 25,0 25 12,0 37 11,0 48 11,11 37 1,12 25 13,11 38 14,11 52 7,18 52 7",
            "0 0 26,0 26 17,0 43 16,16 43 1,17 26 9,17 35 9,16 44 10,16 54 5,21 54 5",
            "0 0 27,0 27 15,15 27 12,15 39 2,15 41 1,16 41 1,0 42 17,17 39 10,17 49 10",
            "0 0 28,0 28 15,15 28 13,15 41 1,15 42 1,0 43 16,16 41 12,16 53 6,22 53 6",
            "0 0 29,0 29 20,0 49 10,10 49 10,20 29 9,20 38 9,20 47 9,20 56 3,23 56 3,26 56 3",
            "0 0 30,0 30 20,0 50 9,9 50 9,20 30 10,20 40 10,18 50 9,27 50 3,27 53 3,27 56 3",
            "0 0 31,0 31 15,0 46 13,13 46 1,14 46 1,15 31 16,13 47 12,25 47 6,25 53 6",
            "0 0 32,0 32 15,0 47 12,12 47 2,14 47 1,14 48 1,15 32 17,12 49 10,22 49 10",
            "0 0 33,0 33 17,0 50 9,17 33 16,17 49 1,9 50 9,18 49 10,28 49 5,28 54 5",
            "0 0 34,0 34 12,12 34 11,12 45 1,0 46 13,23 34 11,13 45 14,27 45 7,27 52 7",
            "0 0 35,0 35 24,24 35 11,24 46 6,30 46 5,30 51 1,24 52 7,31 51 4,31 55 4",
            "0 0 36,0 36 23,23 36 13,23 49 10,33 49 3,33 52 3,33 55 3,33 58 1,34 58 1,35 58 1",
            "0 0 37,0 37 11,0 48 11,11 37 12,11 49 10,21 49 2,23 37 14,21 51 8,29 51 8",
            "0 0 15,0 15 15,15 0 23,15 23 7,22 23 7,0 30 29,29 23 9,29 32 9,29 41 9,29 50 9",
            "0 0 26,0 26 18,0 44 15,15 44 3,26 0 13,26 13 13,18 26 21,15 47 12,27 47 12",
            "0 0 40,0 40 19,19 40 10,19 50 9,28 50 1,29 40 11,28 51 8,36 51 4,36 55 4",
            "0 0 41,0 41 18,18 41 18,36 41 5,36 46 5,36 51 5,36 56 3,39 56 2,39 58 1,40 58 1",
            "0 0 21,0 21 20,0 41 18,18 41 2,21 0 21,20 21 22,18 43 16,34 43 8,34 51 8",
            "0 0 20,0 20 14,14 20 3,17 20 3,20 0 23,14 23 11,0 34 25,25 23 18,25 41 18",
            "0 0 19,0 19 13,13 19 6,19 0 25,13 25 7,20 25 7,0 32 27,27 25 17,27 42 17",
            "0 0 45,0 45 14,14 45 14,28 45 7,28 52 7,35 45 10,35 55 4,39 55 4,43 55 2,43 57 2",
            "0 0 28,28 0 18,28 18 7,28 25 3,0 28 31,31 25 4,35 18 11,31 29 15,31 44 15",
            "0 0 19,0 19 19,19 0 28,19 28 10,0 38 21,21 38 8,29 28 18,21 46 13,34 46 13",
            "0 0 32,0 32 27,32 0 16,32 16 16,27 32 21,27 53 6,33 53 6,39 53 6,45 53 3,45 56 3",
            "0 0 24,0 24 24,0 48 11,11 48 11,22 48 2,24 0 25,24 25 25,22 50 9,31 50 9,40 50 9",
            "0 0 23,0 23 19,0 42 17,19 23 4,23 0 27,19 27 15,17 42 17,34 27 16,34 43 16",
            "0 0 29,29 0 22,29 22 6,29 28 1,0 29 30,30 28 5,30 33 5,35 22 16,30 38 21",
            "0 0 29,29 0 23,29 23 6,0 29 30,35 23 3,35 26 3,30 29 8,38 23 14,30 37 22",
            "0 0 28,28 0 25,28 25 3,0 28 31,31 25 22,31 47 12,43 47 6,43 53 6,49 47 4,49 51 4,49 55 4",
            "0 0 27,27 0 27,0 27 32,32 27 22,32 49 10,42 49 6,42 55 4,48 49 6,46 55 4,50 55 4",
            "0 0 31,0 31 28,31 0 24,31 24 7,28 31 10,38 24 17,28 41 18,46 41 9,46 50 9",
            "0 0 36,0 36 23,23 36 9,32 36 4,36 0 20,36 20 20,32 40 5,23 45 14,37 40 19",
            "0 0 38,0 38 21,38 0 19,38 19 19,21 38 21,42 38 15,42 53 6,48 53 6,54 53 3,54 56 3",
            "0 0 29,29 0 29,0 29 30,30 29 14,44 29 14,30 43 16,46 43 12,46 55 4,50 55 4,54 55 4",
            "0 0 59"
        }, {
            "0 0 1,0 1 1,0 2 1,0 3 1,0 4 1,0 5 1,0 6 1,0 7 1,0 8 1,0 9 1,0 10 1,0 11 1,0 12 1,0 13 1,0 14 1,0 15 1,0 16 1,0 17 1,0 18 1,0 19 1,0 20 1,0 21 1,0 22 1,0 23 1,0 24 1,0 25 1,0 26 1,0 27 1,0 28 1,0 29 1,0 30 1,0 31 1,0 32 1,0 33 1,0 34 1,0 35 1,0 36 1,0 37 1,0 38 1,0 39 1,0 40 1,0 41 1,0 42 1,0 43 1,0 44 1,0 45 1,0 46 1,0 47 1,0 48 1,0 49 1,0 50 1,0 51 1,0 52 1,0 53 1,0 54 1,0 55 1,0 56 1,0 57 1,0 58 1,0 59 1",
            "0 0 2,0 2 2,0 4 2,0 6 2,0 8 2,0 10 2,0 12 2,0 14 2,0 16 2,0 18 2,0 20 2,0 22 2,0 24 2,0 26 2,0 28 2,0 30 2,0 32 2,0 34 2,0 36 2,0 38 2,0 40 2,0 42 2,0 44 2,0 46 2,0 48 2,0 50 2,0 52 2,0 54 2,0 56 2,0 58 2",
            "0 0 3,0 3 3,0 6 3,0 9 3,0 12 3,0 15 3,0 18 3,0 21 3,0 24 3,0 27 3,0 30 3,0 33 3,0 36 3,0 39 3,0 42 3,0 45 3,0 48 3,0 51 3,0 54 3,0 57 3",
            "0 0 4,0 4 4,0 8 4,0 12 4,0 16 4,0 20 4,0 24 4,0 28 4,0 32 4,0 36 4,0 40 4,0 44 4,0 48 4,0 52 4,0 56 4",
            "0 0 5,0 5 5,0 10 5,0 15 5,0 20 5,0 25 5,0 30 5,0 35 5,0 40 5,0 45 5,0 50 5,0 55 5",
            "0 0 6,0 6 6,0 12 6,0 18 6,0 24 6,0 30 6,0 36 6,0 42 6,0 48 6,0 54 6",
            "0 0 7,0 7 7,0 14 7,0 21 7,0 28 7,0 35 7,0 42 7,0 49 7,0 56 4,4 56 3,4 59 1,5 59 1,6 59 1",
            "0 0 8,0 8 8,0 16 8,0 24 8,0 32 8,0 40 8,0 48 8,0 56 4,4 56 4",
            "0 0 9,0 9 9,0 18 9,0 27 9,0 36 9,0 45 9,0 54 6,6 54 3,6 57 3",
            "0 0 10,0 10 10,0 20 10,0 30 10,0 40 10,0 50 10",
            "0 0 11,0 11 11,0 22 11,0 33 11,0 44 11,0 55 5,5 55 3,5 58 2,8 55 3,7 58 2,9 58 2",
            "0 0 12,0 12 12,0 24 12,0 36 12,0 48 12",
            "0 0 13,0 13 13,0 26 13,0 39 13,0 52 8,8 52 5,8 57 3,11 57 2,11 59 1,12 59 1",
            "0 0 14,0 14 14,0 28 14,0 42 14,0 56 4,4 56 4,8 56 4,12 56 2,12 58 2",
            "0 0 15,0 15 15,0 30 15,0 45 15",
            "0 0 16,0 16 16,0 32 16,0 48 12,12 48 4,12 52 4,12 56 4",
            "0 0 17,0 17 17,0 34 17,0 51 9,9 51 4,13 51 4,9 55 5,14 55 3,14 58 2,16 58 1,16 59 1",
            "0 0 18,0 18 18,0 36 18,0 54 6,6 54 6,12 54 6",
            "0 0 19,0 19 19,0 38 11,0 49 11,11 38 8,11 46 8,11 54 6,17 54 2,17 56 2,17 58 2",
            "0 0 20,0 20 20,0 40 20",
            "0 0 21,0 21 21,0 42 9,0 51 9,9 42 12,9 54 6,15 54 6",
            "0 0 22,0 22 22,0 44 16,16 44 6,16 50 6,16 56 4,20 56 2,20 58 2",
            "0 0 23,0 23 23,0 46 14,14 46 9,14 55 5,19 55 4,19 59 1,20 59 1,21 59 1,22 59 1",
            "0 0 24,0 24 24,0 48 12,12 48 12",
            "0 0 25,0 25 25,0 50 10,10 50 10,20 50 5,20 55 5",
            "0 0 26,0 26 26,0 52 8,8 52 8,16 52 8,24 52 2,24 54 2,24 56 2,24 58 2",
            "0 0 27,0 27 27,0 54 6,6 54 6,12 54 6,18 54 6,24 54 3,24 57 3",
            "0 0 28,0 28 16,0 44 16,16 28 12,16 40 12,16 52 8,24 52 4,24 56 4",
            "0 0 29,0 29 10,0 39 10,10 29 19,10 48 1,0 49 11,11 48 12,23 48 6,23 54 6",
            "0 0 30,0 30 30",
            "0 0 31,0 31 10,10 31 10,0 41 19,19 41 1,20 31 11,19 42 12,19 54 6,25 54 6",
            "0 0 32,0 32 16,0 48 12,16 32 16,12 48 12,24 48 8,24 56 4,28 56 4",
            "0 0 33,0 33 27,27 33 6,27 39 6,27 45 6,27 51 6,27 57 3,30 57 3",
            "0 0 34,0 34 26,26 34 8,26 42 8,26 50 8,26 58 2,28 58 2,30 58 2,32 58 2",
            "0 0 35,0 35 25,25 35 10,25 45 10,25 55 5,30 55 5",
            "0 0 36,0 36 24,24 36 12,24 48 12",
            "0 0 37,0 37 23,23 37 14,23 51 9,32 51 5,32 56 4,36 56 1,36 57 1,36 58 1,36 59 1",
            "0 0 38,0 38 22,22 38 16,22 54 6,28 54 6,34 54 4,34 58 2,36 58 2",
            "0 0 39,0 39 21,21 39 9,30 39 9,21 48 12,33 48 6,33 54 6",
            "0 0 40,0 40 20,20 40 20",
            "0 0 18,0 18 18,18 0 23,18 23 13,0 36 24,24 36 7,31 23 10,31 33 10,24 43 17",
            "0 0 42,0 42 18,18 42 18,36 42 6,36 48 6,36 54 6",
            "0 0 43,0 43 17,17 43 17,34 43 9,34 52 4,34 56 4,38 52 5,38 57 3,41 57 2,41 59 1,42 59 1",
            "0 0 44,0 44 16,16 44 16,32 44 12,32 56 4,36 56 4,40 56 4",
            "0 0 45,0 45 15,15 45 15,30 45 15",
            "0 0 46,0 46 14,14 46 14,28 46 14,42 46 4,42 50 4,42 54 4,42 58 2,44 58 2",
            "0 0 47,0 47 13,13 47 13,26 47 13,39 47 8,39 55 5,44 55 3,44 58 2,46 58 1,46 59 1",
            "0 0 48,0 48 12,12 48 12,24 48 12,36 48 12",
            "0 0 24,0 24 24,0 48 12,12 48 12,24 0 25,24 25 25,24 50 10,34 50 10,44 50 5,44 55 5",
            "0 0 30,0 30 30,30 0 20,30 20 20,30 40 20",
            "0 0 27,27 0 24,27 24 3,30 24 3,0 27 33,33 24 18,33 42 18",
            "0 0 40,0 40 20,20 40 20,40 0 12,40 12 12,40 24 12,40 36 12,40 48 12",
            "0 0 20,0 20 20,0 40 20,20 0 33,20 33 27,47 33 6,47 39 6,47 45 6,47 51 6,47 57 3,50 57 3",
            "0 0 30,0 30 30,30 0 24,30 24 24,30 48 12,42 48 12",
            "0 0 40,0 40 20,20 40 20,40 0 15,40 15 15,40 30 15,40 45 15",
            "0 0 28,28 0 28,0 28 32,32 28 24,32 52 8,40 52 8,48 52 8",
            "0 0 45,0 45 15,15 45 15,30 45 15,45 0 12,45 12 12,45 24 12,45 36 12,45 48 12",
            "0 0 40,0 40 20,20 40 20,40 0 18,40 18 18,40 36 18,40 54 6,46 54 6,52 54 6",
            "0 0 24,0 24 24,0 48 12,12 48 12,24 0 35,24 35 25,49 35 10,49 45 10,49 55 5,54 55 5",
            "0 0 60"
        }
    };
}

